'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 27 March 2005 at 1:03:57 pm'!

!Object methodsFor: 'user interface' stamp: 'cr 3/17/2005 04:19'!
explore
	self removed.! !

!Object methodsFor: '*Shrink' stamp: 'cr 3/23/2005 04:45'!
allObjectsReferencingIt
	| result |
	result := OrderedCollection new.
	Object allSubInstances do: [ :si | (si references: self) ifTrue: [result add: si]].
	^WeakArray withAll: result.		"Use weak array so that intermediate results of this method will go away."
! !

!Object methodsFor: '*Shrink' stamp: 'cr 3/23/2005 21:35'!
guesstimatedSize
	"The number of bytes (as far as I can guess) that this object occupies."
	self class isVariable
		ifFalse: [^self class instSize]
		ifTrue: [
			self class isBytes ifTrue: [^self size].
			self class = FloatArray ifTrue: [^self size * 4].
			self class isWords ifTrue: [^self size * 2].
			^ self size * 4.
		].

 ! !

!Object methodsFor: '*Shrink' stamp: 'cr 3/20/2005 03:47'!
references: otherObject
	^self referencesOneOf: {otherObject}.! !

!Object methodsFor: '*Shrink' stamp: 'cr 3/20/2005 03:41'!
referencesOneOf: otherObjects
	self class isPointers ifFalse: [^false].

	self class isVariable
		ifTrue: [
			(1 to: self size) do: [ :index | 
				(otherObjects identityIncludes: (self basicAt: index)) ifTrue: [^true]
			].
		] ifFalse: [
			(1 to: self class allInstVarNames size)
				do: [ :idx | (otherObjects identityIncludes: (self instVarAt: idx)) ifTrue: [^true]]
		].

	^false.

	! !

!Object methodsFor: '*Shrink' stamp: 'cr 3/16/2005 19:21'!
removed
	nil inform: 'method removed.'! !


!AutoStart class methodsFor: 'class initialization' stamp: 'cr 6/5/2004 21:59'!
startUp
	| startupParameters launchers |
	startupParameters _ AbstractLauncher extractParameters.
	
	launchers _ self installedLaunchers collect: [:launcher |
		launcher new].
	launchers do: [:launcher |
		launcher parameters: startupParameters].
	launchers do: [:launcher | launcher startUp].  "This may be broken under Morphic."
! !


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'cr 3/16/2005 19:09'!
mailOut
	"Email a compressed version of this changeset to the squeak-dev list, so that it can be shared with everyone.  (You will be able to edit the email before it is sent.)"

	nil inform: 'removed'.
! !


!DataStream class methodsFor: 'as yet unclassified' stamp: 'cr 3/17/2005 03:31'!
initialize
	"TypeMap maps Smalltalk classes to type ID numbers which identify the data stream primitive formats.  nextPut: writes these IDs to the data stream.  NOTE: Changing these type ID numbers will invalidate all extant data stream files.  Adding new ones is OK.  
	Classes named here have special formats in the file.  If such a class has a subclass, it will use type 9 and write correctly.  It will just be slow.  (Later write the class name in the special format, then subclasses can use the type also.)
	 See nextPut:, next, typeIDFor:, & ReferenceStream>>isAReferenceType:"
	"DataStream initialize"

	| refTypes t |
	refTypes _ OrderedCollection new.
	t _ TypeMap _ Dictionary new: 80. "sparse for fast hashing"

	t at: UndefinedObject put: 1.   refTypes add: 0.
	t at: True put: 2.   refTypes add: 0.
	t at: False put: 3.   refTypes add: 0.
	t at: SmallInteger put: 4.	 refTypes add: 0.
	t at: String put: 5.   refTypes add: 1.
	t at: Symbol put: 6.   refTypes add: 1.
	t at: ByteArray put: 7.   refTypes add: 1.
	t at: Array put: 8.   refTypes add: 1.
	"(type ID 9 is for arbitrary instances of any class, cf. typeIDFor:)"
		refTypes add: 1.
	"(type ID 10 is for references, cf. ReferenceStream>>tryToPutReference:)"
		refTypes add: 0.
	t at: Bitmap put: 11.   refTypes add: 1.
	t at: Metaclass put: 12.   refTypes add: 0.
	"Type ID 13 is used for HyperSqueak User classes that must be reconstructed."
		refTypes add: 1.
	t at: Float put: 14.  refTypes add: 1.
	t at: Rectangle put: 15.  refTypes add: 1.	"Allow compact Rects."
	"type ID 16 is an instance with short header.  See beginInstance:size:"
		refTypes add: 1.
	t at: String put: 17.   refTypes add: 1.	"new String format, 1 or 4 bytes of length"
	t at: WordArray put: 18.  refTypes add: 1.	"bitmap-like"
	t at: WordArrayForSegment put: 19.  refTypes add: 1.		"bitmap-like"
"	t at: SoundBuffer put: 20.  refTypes add: 1."	"And all other word arrays, both 
		16-bit and 32-bit.  See methods in ArrayedCollection.  Overridden in SoundBuffer."
	t at: CompiledMethod put: 21.  refTypes add: 1.	"special creation method"
	"t at:  put: 22.  refTypes add: 0."
	ReferenceStream refTypes: refTypes.		"save it"

	"For all classes that are like WordArrays, store them the way ColorArray is stored.  As bits, and able to change endianness."
	Smalltalk do: [:cls |
		cls isInMemory ifTrue: [
			cls isBehavior ifTrue: [
				cls isPointers not & cls isVariable & cls isWords ifTrue: [
					(t includesKey: cls) ifFalse: [t at: cls put: 20]]]]].! !


!ExternalSettings class methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 14:49'!
unregisterObsoleteClients
	| rc |
	rc := self registeredClients.
	rc removeAll: (rc select: [ :obj | obj class isObsolete]).
! !


!FileStream class methodsFor: 'concrete classes' stamp: 'cr 3/16/2005 02:07'!
concreteStream
	"Who should we really direct class queries to?  "
	^ CrLfFileStream! !


!Flaps class methodsFor: 'predefined flaps' stamp: 'cr 3/22/2005 22:21'!
newNavigatorFlap
	"Answer a newly-created flap which adheres to the bottom edge of the screen and which holds the project navigator controls. (BROKEN!!!!!!  ProjectNavigationMorph removed.)"

	|  aFlapTab aFlap |
"	navBar _ ProjectNavigationMorph preferredNavigator new."
	aFlap _ PasteUpMorph newSticky borderWidth: 0;
			extent: 10@10; "navBar extent + (0@20);"
			color: (Color orange alpha: 0.8);
			beFlap: true;
"			addMorph: navBar beSticky."
			yourself.
	aFlap hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aFlap useRoundedCorners.
	aFlap setNameTo: 'Navigator Flap'.
"	navBar fullBounds.  " "to establish width"
	
	aFlapTab _ FlapTab new referent: aFlap.
	aFlapTab setName: 'Navigator' edge: #bottom color: Color orange.
	aFlapTab position: 9999@9999.  "((navBar width // 2) - (aFlapTab width // 2))
					@ (self currentWorld height - aFlapTab height)."
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.
	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Navigator' "
! !

!Flaps class methodsFor: 'predefined flaps' stamp: 'cr 3/17/2005 04:44'!
quadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap"

	^ #(
	(Browser 				prototypicalToolWindow		'Browser'			'A Browser is a tool that allows you to view all the code of all the classes in the system')
	(TranscriptStream				openMorphicTranscript				'Transcript'			'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.')
	(Workspace				prototypicalToolWindow		'Workspace'			'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.')
	(FileList					prototypicalToolWindow		'File List'			'A File List is a tool for browsing folders and files on disks and on ftp types.')
	(DualChangeSorter		prototypicalToolWindow		'Change Sorter'		'Shows two change sets side by side')
	(SelectorBrowser			prototypicalToolWindow		'Method Finder'		'A tool for discovering methods by providing sample values for arguments and results')
	(MessageNames			prototypicalToolWindow		'Message Names'		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.')
	"(Preferences			preferencesControlPanel	'Preferences'			'Allows you to control numerous options')"
	(Utilities				recentSubmissionsWindow	'Recent'				'A message browser that tracks the most recently-submitted methods')
	(ProcessBrowser			prototypicalToolWindow		'Processes'			'A Process Browser shows you all the running processes')
	(Preferences			annotationEditingWindow	'Annotations'		'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.')
	(Scamper				newOpenableMorph			'Scamper'			'A web browser')
	(Celeste					newOpenableMorph			'Celeste'				'Celeste -- an EMail reader')
	(PackagePaneBrowser	prototypicalToolWindow		'Packages'			'Package Browser:  like a System Browser, except that if has extra level of categorization in the top-left pane, such that class-categories are further organized into groups called "packages"')
	(ChangeSorter			prototypicalToolWindow		'Change Set'			'A tool that allows you to view and manipulate all the code changes in a single change set')

)! !


!Form methodsFor: 'filling' stamp: 'cr 3/17/2005 03:56'!
floodFill: aColor at: interiorPoint tolerance: tolerance
	"Fill the shape (4-connected) at interiorPoint.  The algorithm is based on Paul Heckbert's 'A Seed Fill Algorithm', Graphic Gems I, Academic Press, 1990.
	NOTE (ar): This variant has been heavily optimized to prevent the overhead of repeated calls to BitBlt. Usually this is a really big winner but the runtime now depends a bit on the complexity of the shape to be filled. For extremely complex shapes (say, a Hilbert curve) with very few pixels to fill it can be slower than #floodFill2:at: since it needs to repeatedly read the source bits. However, in all practical cases I found this variant to be 15-20 times faster than anything else.
	Further note (di):  I have added a feature that allows this routine to fill areas of approximately constant color (such as  photos, scans, and jpegs).  It does this by computing a color map for the peeker that maps all colors close to 'old' into colors identical to old.  This mild colorblindness achieves the desired effect with no further change or degradation of the algorithm.  tolerance should be 0 (exact match), or a value corresponding to those returned by Color>>diff:, with 0.1 being a reasonable starting choice."

	| peeker poker stack old new x y top x1 x2 dy left goRight span spanBits w box debug |
	debug _ false. "set it to true to see the filling process"
	box _ interiorPoint extent: 1@1.
	span _ Form extent: width@1 depth: 32.
	spanBits _ span bits.

	peeker _ BitBlt current toForm: span.
	peeker 
		sourceForm: self; 
		combinationRule: 3; 
		width: width; 
		height: 1.

	"read old pixel value"
	peeker sourceOrigin: interiorPoint; destOrigin: interiorPoint x @ 0; width: 1; copyBits.
	old _ spanBits at: interiorPoint x + 1.

	"compute new value (take care since the algorithm will fail if old = new)"
	new _ self privateFloodFillValue: aColor.
	old = new ifTrue: [^ box].
	tolerance > 0 ifTrue:
		["Set up color map for approximate fills"
		peeker colorMap: (self floodFillMapFrom: self to: span mappingColorsWithin: tolerance to: old)].

	poker _ BitBlt current toForm: self.
	poker 
		fillColor: aColor;
		combinationRule: 3;
		width: width;
		height: 1.

	stack _ OrderedCollection new: 50.
	x _ interiorPoint x.
	y _ interiorPoint y.
	(y >= 0 and:[y < height]) ifTrue:[
		stack addLast: {y. x. x. 1}. "y, left, right, dy"
		stack addLast: {y+1. x. x. -1}].

	[stack isEmpty] whileFalse:[
		debug ifTrue:[self displayOn: Display].
		top _ stack removeLast.
		y _ top at: 1. x1 _ top at: 2. x2 _ top at: 3. dy _ top at: 4.
		y _ y + dy.
"		debug ifTrue:[
			(Line from: (x1-1)@y to: (x2+1)@y 
				withForm: (Form extent: 1@1 depth: 8) fillWhite) displayOn: Display].
"
		"Segment of scanline (y-dy) for x1 <= x <= x2 was previously filled.
		Now explore adjacent pixels in scanline y."
		peeker sourceOrigin: 0@y; destOrigin: 0@0; width: width; copyBits.
			"Note: above is necessary since we don't know where we'll end up filling"
		x _ x1.
		w _ 0.
		[x >= 0 and:[(spanBits at: x+1) = old]] whileTrue:[
			w _ w + 1.
			x _ x - 1].
		w > 0 ifTrue:[
			"overwrite pixels"
			poker destOrigin: x+1@y; width: w; copyBits.
			box _ box quickMerge: ((x+1@y) extent: w@1)].
		goRight _ x < x1.
		left _ x+1.
		(left < x1 and:[y-dy >= 0 and:[y-dy < height]]) 
			ifTrue:[stack addLast: {y. left. x1-1. 0-dy}].
		goRight ifTrue:[x _ x1 + 1].
		[
			goRight ifTrue:[
				w _ 0.
				[x < width and:[(spanBits at: x+1) = old]] whileTrue:[
					w _ w + 1.
					x _ x + 1].
				w > 0 ifTrue:[
					"overwrite pixels"
					poker destOrigin: (x-w)@y; width: w; copyBits.
					box _ box quickMerge: ((x-w@y) extent: w@1)].
				(y+dy >= 0 and:[y+dy < height]) 
					ifTrue:[stack addLast: {y. left. x-1. dy}].
				(x > (x2+1) and:[y-dy >= 0 and:[y-dy >= 0]]) 
					ifTrue:[stack addLast: {y. x2+1. x-1. 0-dy}]].
			[(x _ x + 1) <= x2 and:[(spanBits at: x+1) ~= old]] whileTrue.
			left _ x.
			goRight _ true.
		x <= x2] whileTrue.
	].
	^box! !


!Form class methodsFor: 'instance creation' stamp: 'cr 3/27/2005 13:03'!
fromFileNamed: fileName
	"Read a Form or ColorForm from the given file."

	| file form |
	file _ (FileStream readOnlyFileNamed: fileName) binary.
	form _ self fromBinaryStream: file.
"We don' need no steekin' resourceManager.  (Also, #urlForFileNamed: is gone."
"
	Smalltalk isMorphic ifTrue:[
		Project current resourceManager
			addResource: form
			url: (FileDirectory urlForFileNamed: file name) asString].
"
	file close.
	^ form
! !


!FormView methodsFor: 'controller access' stamp: 'cr 3/17/2005 02:54'!
defaultControllerClass  ^ NoController! !


!MethodFinder methodsFor: 'initialize' stamp: 'cr 3/20/2005 01:48'!
initialize2
	"The methods we are allowed to use.  (MethodFinder new initialize) "

"Set"
	#("in class" sizeFor:
"testing" "adding" "removing" "enumerating"
"private" array findElementOrNil: 
"accessing" someElement) do: [:sel | Approved add: sel].

"Dictionary, IdentityDictionary, IdentitySet"
	#("accessing" associationAt: associationAt:ifAbsent: at:ifPresent: keyAtIdentityValue: keyAtIdentityValue:ifAbsent: keyAtValue: keyAtValue:ifAbsent: keys
"testing" includesKey: ) do: [:sel | Approved add: sel].
	#(removeKey: removeKey:ifAbsent:
) do: [:sel | AddAndRemove add: sel].

"LinkedList, Interval, MappedCollection"
	#("in class"  from:to: from:to:by:
"accessing" contents) do: [:sel | Approved add: sel].
	#(
"adding" addFirst: addLast:) do: [:sel | AddAndRemove add: sel].

"OrderedCollection, SortedCollection"
	#("accessing" after: before:
"copying" copyEmpty
"adding"  growSize
"removing" "enumerating" "private" 
"accessing" sortBlock) do: [:sel | Approved add: sel].
	#("adding" add:after: add:afterIndex: add:before: addAllFirst: addAllLast: addFirst: addLast:
"removing" removeAt: removeFirst removeLast
"accessing" sortBlock:) do: [:sel | AddAndRemove add: sel].

"Character"
	#("in class, instance creation" allCharacters digitValue: new separators
	"accessing untypeable characters" backspace cr enter lf linefeed nbsp newPage space tab
	"constants" alphabet characterTable
"accessing" asciiValue digitValue
"comparing"
"testing" isAlphaNumeric isDigit isLetter isLowercase isSafeForHTTP isSeparator isSpecial isUppercase isVowel tokenish
"copying"
"converting" asIRCLowercase asLowercase asUppercase
	) do: [:sel | Approved add: sel].

"String"
	#("in class, instance creation" crlf fromPacked:
	"primitives" findFirstInString:inSet:startingAt: indexOfAscii:inString:startingAt: 	"internet" valueOfHtmlEntity:
"accessing" byteAt: endsWithDigit findAnySubStr:startingAt: findBetweenSubStrs: findDelimiters:startingAt: findString:startingAt: findString:startingAt:caseSensitive: findTokens: findTokens:includes: findTokens:keep: includesSubString: includesSubstring:caseSensitive: indexOf:startingAt: indexOfAnyOf: indexOfAnyOf:ifAbsent: indexOfAnyOf:startingAt: indexOfAnyOf:startingAt:ifAbsent: lineCorrespondingToIndex: lineCount lineNumber: skipAnySubStr:startingAt: skipDelimiters:startingAt: startsWithDigit
"comparing" alike: beginsWith: caseSensitiveLessOrEqual: charactersExactlyMatching: compare: crc16 endsWith: endsWithAnyOf: sameAs: startingAt:match:startingAt:
"copying" copyReplaceTokens:with: padded:to:with:
"converting" asByteArray asDate asDisplayText asFileName asHtml asLegalSelector asPacked asParagraph asText asTime asUnHtml asUrl asUrlRelativeTo: capitalized compressWithTable: contractTo: correctAgainst: encodeForHTTP initialIntegerOrNil keywords quoted sansPeriodSuffix splitInteger stemAndNumericSuffix substrings surroundedBySingleQuotes truncateWithElipsisTo: withBlanksTrimmed withFirstCharacterDownshifted withNoLineLongerThan: withSeparatorsCompacted withoutLeadingDigits withoutTrailingBlanks
"displaying" "printing"
"system primitives" compare:with:collated: 
"Celeste" withCRs
"internet" decodeMimeHeader decodeQuotedPrintable "replaceHtmlCharRefs" unescapePercents withInternetLineEndings withSqueakLineEndings withoutQuoting
"testing" isAllSeparators lastSpacePosition
"paragraph support" indentationIfBlank:
"arithmetic" ) do: [:sel | Approved add: sel].
	#(byteAt:put: translateToLowercase match:) do: [:sel | AddAndRemove add: sel].

"Symbol"
	#("in class, private" hasInterned:ifTrue:
	"access" morePossibleSelectorsFor: possibleSelectorsFor: selectorsContaining: thatStarts:skipping:
"accessing" "comparing" "copying" "converting" "printing" 
"testing" isInfix isKeyword isPvtSelector isUnary) do: [:sel | Approved add: sel].

"Array"
	#("comparing" "converting" evalStrings 
"printing" "private" hasLiteralSuchThat:) do: [:sel | Approved add: sel].

"Array2D"
	#("access" at:at: atCol: atCol:put: atRow: extent extent:fromArray: height width width:height:type:) do: [:sel | Approved add: sel].
	#(at:at:add: at:at:put: atRow:put: ) do: [:sel | AddAndRemove add: sel].

"ByteArray"
	#("accessing" doubleWordAt: wordAt: 
"platform independent access" longAt:bigEndian: shortAt:bigEndian: unsignedLongAt:bigEndian: unsignedShortAt:bigEndian: 
"converting") do: [:sel | Approved add: sel].
	#(doubleWordAt:put: wordAt:put: longAt:put:bigEndian: shortAt:put:bigEndian: unsignedLongAt:put:bigEndian: unsignedShortAt:put:bigEndian:
	) do: [:sel | AddAndRemove add: sel].

"FloatArray"		"Dont know what happens when prims not here"
	false ifTrue: [#("accessing" "arithmetic" *= += -= /=
"comparing"
"primitives-plugin" primAddArray: primAddScalar: primDivArray: primDivScalar: primMulArray: primMulScalar: primSubArray: primSubScalar:
"primitives-translated" primAddArray:withArray:from:to: primMulArray:withArray:from:to: primSubArray:withArray:from:to:
"converting" "private" "user interface") do: [:sel | Approved add: sel].
	].

"IntegerArray, WordArray"
"RunArray"
	#("in class, instance creation" runs:values: scanFrom:
"accessing" runLengthAt: 
"adding" "copying"
"private" runs values) do: [:sel | Approved add: sel].
	#(coalesce addLast:times: repeatLast:ifEmpty: repeatLastIfEmpty:
		) do: [:sel | AddAndRemove add: sel].

"Stream  -- many operations change its state"
	#("testing" atEnd) do: [:sel | Approved add: sel].
	#("accessing" next: nextMatchAll: nextMatchFor: upToEnd
next:put: nextPut: nextPutAll: "printing" print: printHtml:
	) do: [:sel | AddAndRemove add: sel].

"PositionableStream"
	#("accessing" contentsOfEntireFile originalContents peek peekFor: "testing"
"positioning" position ) do: [:sel | Approved add: sel].
	#(nextDelimited: nextLine upTo: position: reset resetContents setToEnd skip: skipTo: upToAll: ) do: [:sel | AddAndRemove add: sel].
	"Because it is so difficult to test the result of an operation on a Stream (you have to supply another Stream in the same state), we don't support Streams beyond the basics.  We want to find the messages that convert Streams to other things."

"ReadWriteStream"
	#("file status" closed) do: [:sel | Approved add: sel].
	#("accessing" next: on: ) do: [:sel | AddAndRemove add: sel].

"WriteStream"
	#("in class, instance creation" on:from:to: with: with:from:to:
		) do: [:sel | Approved add: sel].
	#("positioning" resetToStart
"character writing" crtab crtab:) do: [:sel | AddAndRemove add: sel].

"LookupKey, Association, Link"
	#("accessing" key nextLink) do: [:sel | Approved add: sel].
	#(key: key:value: nextLink:) do: [:sel | AddAndRemove add: sel].

"Point"
	#("in class, instance creation" r:degrees: x:y:
"accessing" x y "comparing" "arithmetic" "truncation and round off"
"polar coordinates" degrees r theta
"point functions" bearingToPoint: crossProduct: dist: dotProduct: eightNeighbors flipBy:centerAt: fourNeighbors grid: nearestPointAlongLineFrom:to: nearestPointOnLineFrom:to: normal normalized octantOf: onLineFrom:to: onLineFrom:to:within: quadrantOf: rotateBy:centerAt: transposed unitVector
"converting" asFloatPoint asIntegerPoint corner: extent: rect:
"transforming" adhereTo: rotateBy:about: scaleBy: scaleFrom:to: translateBy: "copying"
"interpolating" interpolateTo:at:) do: [:sel | Approved add: sel].

"Rectangle"
	#("in class, instance creation" center:extent: encompassing: left:right:top:bottom: 
	merging: origin:corner: origin:extent: 
"accessing" area bottom bottomCenter bottomLeft bottomRight boundingBox center corner corners innerCorners left leftCenter origin right rightCenter top topCenter topLeft topRight
"comparing"
"rectangle functions" adjustTo:along: amountToTranslateWithin: areasOutside: bordersOn:along: encompass: expandBy: extendBy: forPoint:closestSideDistLen: insetBy: insetOriginBy:cornerBy: intersect: merge: pointNearestTo: quickMerge: rectanglesAt:height: sideNearestTo: translatedToBeWithin: withBottom: withHeight: withLeft: withRight: withSide:setTo: withTop: withWidth:
"testing" containsPoint: containsRect: hasPositiveExtent intersects: isTall isWide
"truncation and round off"
"transforming" align:with: centeredBeneath: newRectFrom: squishedWithin: "copying"
	) do: [:sel | Approved add: sel].

"Color"
	#("in class, instance creation" colorFrom: colorFromPixelValue:depth: fromRgbTriplet: gray: h:s:v: r:g:b: r:g:b:alpha: r:g:b:range:
	"named colors" black blue brown cyan darkGray gray green lightBlue lightBrown lightCyan lightGray lightGreen lightMagenta lightOrange lightRed lightYellow magenta orange red transparent veryDarkGray veryLightGray veryVeryDarkGray veryVeryLightGray white yellow
	"other" colorNames indexedColors pixelScreenForDepth: quickHighLight:
"access" alpha blue brightness green hue luminance red saturation
"equality"
"queries" isBitmapFill isBlack isGray isSolidFill isTranslucent isTranslucentColor
"transformations" alpha: dansDarker darker lighter mixed:with: muchLighter slightlyDarker slightlyLighter veryMuchLighter alphaMixed:with:
"groups of shades" darkShades: lightShades: mix:shades: wheel:
"printing" shortPrintString
"other" colorForInsets rgbTriplet
"conversions" asB3DColor asColor balancedPatternForDepth: bitPatternForDepth: closestPixelValue1 closestPixelValue2 closestPixelValue4 closestPixelValue8 dominantColor halfTonePattern1 halfTonePattern2 indexInMap: pixelValueForDepth: pixelWordFor:filledWith: pixelWordForDepth: scaledPixelValue32
"private" privateAlpha privateBlue privateGreen privateRGB privateRed "copying"
	) do: [:sel | Approved add: sel].

"	For each selector that requires a block argument, add (selector argNum) 
		to the set Blocks."
"ourClasses _ #(Object Boolean True False UndefinedObject Behavior ClassDescription Class Metaclass MethodContext BlockContext Message Magnitude Date Time Number Integer SmallInteger LargeNegativeInteger LargePositiveInteger Float Fraction Random Collection SequenceableCollection ArrayedCollection Bag Set Dictionary IdentityDictionary IdentitySet LinkedList Interval MappedCollection OrderedCollection SortedCollection Character String Symbol Array Array2D ByteArray FloatArray IntegerArray WordArray RunArray Stream PositionableStream ReadWriteStream WriteStream LookupKey Association Link Point Rectangle Color).
ourClasses do: [:clsName | cls _ Smalltalk at: clsName.
	(cls selectors) do: [:aSel |
		((Approved includes: aSel) or: [AddAndRemove includes: aSel]) ifTrue: [
			(cls formalParametersAt: aSel) withIndexDo: [:tName :ind |
				(tName endsWith: 'Block') ifTrue: [
					Blocks add: (Array with: aSel with: ind)]]]]].
"
#((timesRepeat: 1 ) (indexOf:ifAbsent: 2 ) (pairsCollect: 1 ) (mergeSortFrom:to:by: 3 ) (ifNotNil:ifNil: 1 ) (ifNotNil:ifNil: 2 ) (ifNil: 1 ) (at:ifAbsent: 2 ) (ifNil:ifNotNil: 1 ) (ifNil:ifNotNil: 2 ) (ifNotNil: 1 ) (at:modify: 2 ) (identityIndexOf:ifAbsent: 2 ) (sort: 1 ) (sortBlock: 1 ) (detectMax: 1 ) (repeatLastIfEmpty: 1 ) (allSubclassesWithLevelDo:startingLevel: 1 ) (keyAtValue:ifAbsent: 2 ) (in: 1 ) (ifTrue: 1 ) (or: 1 ) (select: 1 ) (inject:into: 2 ) (ifKindOf:thenDo: 2 ) (forPoint:closestSideDistLen: 2 ) (value:ifError: 2 ) (selectorsDo: 1 ) (removeAllSuchThat: 1 ) (keyAtIdentityValue:ifAbsent: 2 ) (detectMin: 1 ) (detect:ifNone: 1 ) (ifTrue:ifFalse: 1 ) (ifTrue:ifFalse: 2 ) (detect:ifNone: 2 ) (hasLiteralSuchThat: 1 ) (indexOfAnyOf:ifAbsent: 2 ) (reject: 1 ) (newRectFrom: 1 ) (removeKey:ifAbsent: 2 ) (at:ifPresent: 2 ) (associationAt:ifAbsent: 2 ) (withIndexCollect: 1 ) (repeatLast:ifEmpty: 2 ) (findLast: 1 ) (indexOf:startingAt:ifAbsent: 3 ) (remove:ifAbsent: 2 ) (ifFalse:ifTrue: 1 ) (ifFalse:ifTrue: 2 ) (caseOf:otherwise: 2 ) (count: 1 ) (collect: 1 ) (sortBy: 1 ) (and: 1 ) (asSortedCollection: 1 ) (with:collect: 2 ) (sourceCodeAt:ifAbsent: 2 ) (detect: 1 ) (scopeHas:ifTrue: 2 ) (collectWithIndex: 1 ) (compiledMethodAt:ifAbsent: 2 ) (bindWithTemp: 1 ) (detectSum: 1 ) (indexOfSubCollection:startingAt:ifAbsent: 3 ) (findFirst: 1 ) (sourceMethodAt:ifAbsent: 2 ) (collect:thenSelect: 1 ) (collect:thenSelect: 2 ) (select:thenCollect: 1 ) (select:thenCollect: 2 ) (ifFalse: 1 ) (indexOfAnyOf:startingAt:ifAbsent: 3 ) (indentationIfBlank: 1 ) ) do: [:anArray |
	Blocks add: anArray].

self initialize3.

"
MethodFinder new initialize.
MethodFinder new organizationFiltered: TranslucentColor class 
"
"Do not forget class messages for each of these classes"
! !


!MethodInterface methodsFor: 'access' stamp: 'cr 3/22/2005 06:08'!
printOn: aStream
	"print the receiver on a stream.  Overridden to provide details about wording, selector, result type, and companion setter."

	super printOn: aStream.

	(elementSymbol isKindOf: Symbol) ifFalse: [^self].		"Bug fix."

	aStream nextPutAll: ' - wording: ''', self elementWording asString, ''' selector: #', selector asString.
	self argumentVariables size > 0 ifTrue:
		[aStream nextPutAll: 'Arguments: '.
		argumentVariables doWithIndex:
			[:aVariable :anIndex | 
				aStream nextPutAll: 'argument #', anIndex printString, ' name = ', aVariable variableName asString, ', type = ', aVariable variableType]].
	resultSpecification ifNotNil:
		[aStream nextPutAll: ' result type = ', resultSpecification resultType asString.
		resultSpecification companionSetterSelector ifNotNil:
			[aStream nextPutAll: ' setter = ', resultSpecification companionSetterSelector asString]]
	! !


!Morph methodsFor: 'menus' stamp: 'cr 3/22/2005 22:15'!
adMiscExtrasTo: aMenu
	"Add a submenu of miscellaneous extra items to the menu."

	| subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	(self isWorldMorph not and: [(self renderedMorph isKindOf: SystemWindow) not])
		ifTrue: [subMenu add: 'put in a window' action: #embedInWindow].

	self isWorldMorph ifFalse:
		[subMenu add: 'adhere to edge...' action: #adhereToEdge.
		subMenu addLine].
"
	realOwner _ (realMorph _ self topRendererOrSelf) owner.
	(realOwner isKindOf: TextPlusPasteUpMorph) ifTrue:
		[subMenu add: 'GeeMail stuff...' subMenu: (realOwner textPlusMenuFor: realMorph)].
"
	self affiliatedSelector ifNotNil:
		[subMenu add: 'open a messenger' action: #openMessenger.
		subMenu balloonTextForLastItem: 'Open a Messenger on the actual method call used when the button action of this object is triggered.'.
		subMenu addLine].

	subMenu
		add: 'add mouse up action' action: #addMouseUpAction;
		add: 'remove mouse up action' action: #removeMouseUpAction;
		add: 'hand me tiles to fire this button' action: #handMeTilesToFire.
	subMenu addLine.
	subMenu add: 'arrowheads on pen trails...' action: #setArrowheads.
	subMenu addLine.

	subMenu defaultTarget: self topRendererOrSelf.
	subMenu add: 'draw new path' action: #definePath.
	subMenu add: 'follow existing path' action: #followPath.
	subMenu add: 'delete existing path' action: #deletePath.
	subMenu addLine.

"	self addGenieMenuItems: subMenu hand: ActiveHand."

	aMenu add: 'extras...' subMenu: subMenu! !

!Morph methodsFor: 'menus' stamp: 'cr 3/17/2005 04:04'!
addHaloActionsTo: aMenu
	"Add items to aMenu representing actions requestable via halo"

	| subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu addTitle: self externalName.
	subMenu addStayUpItemSpecial.
	subMenu addLine.
	subMenu add: 'delete' action: #dismissViaHalo.
	subMenu balloonTextForLastItem: 'Delete this object -- warning -- can be destructive!!'.

	self maybeAddCollapseItemTo: subMenu.
	subMenu add: 'grab' action: #openInHand.
	subMenu balloonTextForLastItem: 'Pick this object up -- warning, since this removes it from its container, it can have adverse effects.'.

	subMenu addLine.

	subMenu add: 'resize' action: #resizeFromMenu.
	subMenu balloonTextForLastItem: 'Change the size of this object'.

	subMenu add: 'duplicate' action: #maybeDuplicateMorph.
	subMenu balloonTextForLastItem: 'Hand me a copy of this object'.

	subMenu addLine.
"	subMenu add: 'property sheet' target: self renderedMorph action: #openAPropertySheet."
	subMenu balloonTextForLastItem: 'Open a property sheet for me. Allows changing lots of stuff at once.'.

	subMenu add: 'set color' target: self renderedMorph action: #changeColor.
	subMenu balloonTextForLastItem: 'Change the color of this object'.

	subMenu add: 'viewer' target: self action: #beViewed.
	subMenu balloonTextForLastItem: 'Open a Viewer that will allow everything about this object to be seen and controlled.'.

	subMenu add: 'tile browser' target: self action: #openInstanceBrowserWithTiles.
	subMenu balloonTextForLastItem: 'Open a tool that will facilitate tile scripting of this object.'.

	subMenu add: 'hand me a tile' target: self action: #tearOffTile.
	subMenu balloonTextForLastItem: 'Hand me a tile represting this object'.
	subMenu addLine.

	subMenu add: 'inspect' target: self action: #inspect.
	subMenu balloonTextForLastItem: 'Open an Inspector on this object'.

	aMenu add: 'halo actions...' subMenu: subMenu
! !

!Morph methodsFor: 'menus' stamp: 'cr 3/23/2005 17:40'!
printPSToFileNamed: aString
	"Ask the user for a filename and print this morph as postscript."
	self removed.
! !

!Morph methodsFor: 'printing' stamp: 'cr 3/23/2005 17:35'!
clipPostscript
	self removed.
! !

!Morph methodsFor: 'fileIn/out' stamp: 'cr 3/17/2005 04:07'!
saveDocPane
	self removed.! !

!Morph methodsFor: 'WiW support' stamp: 'cr 3/17/2005 04:02'!
eToyRejectDropMorph: morphToDrop event: evt

	| tm am |

	tm _ TextMorph new 
		beAllFont: ((TextStyle named: #ComicBold) fontOfSize: 24);
		contents: 'GOT IT!!'.
	(am _ AlignmentMorph new)
		color: Color yellow;
		layoutInset: 10;
		useRoundedCorners;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		addMorph: tm;
		fullBounds;
		position: (self bounds center - (am extent // 2));
		openInWorld: self world.
"
	(SampledSound soundNames includes: 'yum') ifFalse: [
		(FileDirectory default fileExists: '') ifTrue: [
			SampledSound addLibrarySoundNamed: 'yum' fromAIFFfileNamed: 'yum.aif'
		].
	].
	(SampledSound soundNames includes: 'yum') ifTrue: [
		SampledSound playSoundNamed: 'yum'
	].
"
	morphToDrop rejectDropMorphEvent: evt.		"send it back where it came from"
	am delete
! !

!Morph methodsFor: 'piano rolls' stamp: 'cr 3/17/2005 04:03'!
justDroppedIntoPianoRoll: pianoRoll event: evt
	
	self removed.! !

!Morph methodsFor: 'genie-menu' stamp: 'cr 3/16/2005 19:30'!
changeGestureDictionary
	"Asks the user for a new gesture dictionary name"
	self removed.! !

!Morph methodsFor: 'genie-menu' stamp: 'cr 3/16/2005 19:32'!
hasReferencedGestureDictionary
	"Is the gesture dictionary dicrectly referenced by this object or is it linked by name?"

	^ false.	"removed"

! !

!Morph methodsFor: 'genie-menu' stamp: 'cr 3/16/2005 19:30'!
makeOwnSubGestureDictionary
	"Make a sud-dictionary of the assigned gesture dictionary and assign it to this object"
	self removed.
! !

!Morph methodsFor: 'genie-dispatching' stamp: 'cr 3/16/2005 19:33'!
gestureCommand: aCRGesture
	"If the gesture event is a command, execute the corresponding action"
	self removed.
! !

!Morph methodsFor: 'genie-processing' stamp: 'cr 3/16/2005 19:32'!
defaultGestureDictionaryOrName
	"This method returns the default gesture dictionary name for the instances 
	of a Morph class. (It's also possible to directly return a dictionary but it's much
	more flexible to return the name).
	This generic implementation returns the class name if there is a dictionary 
	exported under this name. If not, it tries the name of the superclass, etc."

	^#Text.		"removed.  This might help things not break but really, don't expect it to work"! !

!Morph methodsFor: 'genie-processing' stamp: 'cr 3/16/2005 19:32'!
gestureDictionary
	"This method is invoked to determine the gesture dictionary of the Morph.
	Usually, gesture dictionaries are identified by (exported) names and so this method just
	converts names to dictionaries if necessary"

	^nil.		"code removed."! !

!Morph methodsFor: 'genie-processing' stamp: 'cr 3/17/2005 01:38'!
handlesGestureStart: anEvent
	"If true, the gesture handler is started when the morph gets a red button down
	event.
	If there is a gesture Handler or an EventHandler assigned to the object, 
	let it decide what happens.
	Otherwise, return true if there is a valid default dictionary."
	^false.

! !


!BookMorph methodsFor: 'initialization' stamp: 'cr 3/17/2005 01:54'!
fromURL: url
	"Make a book from an index and a bunch of pages on a server.  NOT showing any page!!"

	self error: 'removed'.
! !

!BookMorph methodsFor: 'sorting' stamp: 'cr 3/17/2005 03:10'!
acceptSortedContentsFrom: aHolder
	"Update my page list from the given page sorter."

	| goodPages rejects toAdd |
	goodPages _ OrderedCollection new.
	rejects _ OrderedCollection new.
	aHolder submorphs doWithIndex: [:m :i |
		toAdd _ nil.
		(m isKindOf: PasteUpMorph) ifTrue: [toAdd _ m].
		(m isKindOf: BookPageThumbnailMorph) ifTrue: [
			toAdd _ m page.
			m bookMorph == self ifFalse: [
				"borrowed from another book. preserve the original"
				toAdd _ toAdd veryDeepCopy.	

				"since we came from elsewhere, cached strings are wrong"
				self removeProperty: #allTextUrls.
				self removeProperty: #allText.
			].
		].
		toAdd class == String ifTrue: ["a url"
			toAdd _ pages detect: [:aPage | aPage url = toAdd] ifNone: [toAdd]].
		toAdd class == String ifTrue: [].

		toAdd ifNil: [rejects add: m]
			ifNotNil: [goodPages add: toAdd]].

	self newPages: goodPages.
	goodPages size = 0 ifTrue: [self insertPage].
	rejects size > 0 ifTrue: [self inform: rejects size printString, ' objects vanished in this process.']
! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/16/2005 15:53'!
bookmarkForThisPage
	"If this book exists on a server, make the reference via a URL"

	nil inform: 'removed'.
! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 03:17'!
getStemUrl
	"Try to find the old place where this book was stored. Confirm with the 
	user. Else ask for new place."

	^'bogus-stem-url'! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 03:21'!
menuPageSoundFor: target event: evt
	self removed.! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 03:21'!
reload
	"Fetch the pages of this book from the server again.  For all pages that have not been modified, keep current ones.  Use new pages.  For each, look up in cache, if time there is equal to time of new, and its in, use the current morph.
	Later do fancy things when a page has changed here, and also on the server."

	self removed.! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 04:09'!
reserveUrls
	"Save a dummy version of the book first, assign all pages URLs, write dummy files to reserve the url, and write the index.  Good when I have pages with interpointing bookmarks."
	self removed.
! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 04:09'!
reserveUrlsIfNeeded
	"See if this book needs to pre-allocate urls.  Harmless if have urls already.  Actually writes dummy files to reserve names."
	self removed.! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/16/2005 15:52'!
saveAsNumberedURLs
	"Write out all pages in this book that are not showing, onto a server.  The local disk could be the server.  For any page that does not have a SqueakPage and a url already, name that page file by its page number.  Any pages that are already totally out will stay that way."

	nil inform: 'removed'.
! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 01:56'!
saveOneOnURL
	"Write out this single page onto a server.  See savePagesOnURL.  (Don't compute the texts, only this page's is written.)"

	nil inform: 'removed'.
! !

!BookMorph methodsFor: 'menu' stamp: 'cr 3/16/2005 15:53'!
savePagesOnURL
	"Write out all pages in this book onto a server.  For any page that does not have a SqueakPage and a url already, ask the user for one.  Give the option of naming all page files by page number.  Any pages that are not in memory will stay that way.  The local disk could be the server."

	nil inform: 'removed'.
! !

!BookMorph methodsFor: 'printing' stamp: 'cr 3/23/2005 17:39'!
printPSToFile
	"Ask the user for a filename and print this morph as postscript."
	self removed.! !


!EventRecorderMorph methodsFor: 'initialization' stamp: 'cr 3/17/2005 03:33'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
"	aCustomMenu add: 'add voice controls' action: #addVoiceControls."
	aCustomMenu add: 'add journal file' action: #addJournalFile.
! !


!GraphMorph methodsFor: 'menu' stamp: 'cr 3/16/2005 19:16'!
openWaveEditor
	nil inform: 'removed'.
! !

!GraphMorph methodsFor: 'commands' stamp: 'cr 3/17/2005 03:57'!
loadSineWave
	self removed.! !


!HaloMorph methodsFor: 'private' stamp: 'cr 3/17/2005 04:04'!
doRecolor: evt with: aHandle
	"The mouse went down in the 'recolor' halo handle.  Allow the user to change the color of the innerTarget"

	evt hand obtainHalo: self.
	(aHandle containsPoint: evt cursorPoint)
		ifFalse:  "only do it if mouse still in handle on mouse up"
			[self delete.
			target addHalo: evt]
		ifTrue:
			[innerTarget changeColor.
			self showingDirectionHandles ifTrue: [self addHandles]]! !

!HaloMorph methodsFor: 'handles' stamp: 'cr 3/17/2005 02:54'!
addPoohHandle: ignored ^self! !


!HandMorph methodsFor: 'genie' stamp: 'cr 3/17/2005 01:47'!
ensureGenieGestureProcessor
	genieGestureProcessor := nil.
! !

!HandMorph methodsFor: 'genie' stamp: 'cr 3/16/2005 15:59'!
switchGenieEnabled
	nil inform: 'removed'.
! !


!Morph class methodsFor: 'fileIn/Out' stamp: 'cr 3/17/2005 04:11'!
fromFileName: fullName
	"Reconstitute a Morph from the file, presumed to be represent a Morph saved
	via the SmartRefStream mechanism, and open it in an appropriate Morphic world"

 	| aFileStream morphOrList |
	aFileStream _ FileStream oldFileNamed: fullName.
	morphOrList _ aFileStream fileInObjectAndCode.
"	(morphOrList isKindOf: SqueakPage) ifTrue: [morphOrList _ morphOrList contentsMorph]."
	Smalltalk isMorphic
		ifTrue: [ActiveWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[morphOrList isMorph ifFalse: [self inform: 'Can only load a single morph
into an mvc project via this mechanism.'].
			morphOrList openInWorld]! !


!BookMorph class methodsFor: 'fileIn/Out' stamp: 'cr 3/17/2005 03:13'!
openFromFile: fullName
	"Reconstitute a Morph from the selected file, presumed to be represent
	a Morph saved via the SmartRefStream mechanism, and open it in an
	appropriate Morphic world"

	self removed.! !


!ParagraphEditor methodsFor: 'menu messages' stamp: 'cr 3/17/2005 04:29'!
languagePrefs
	"Lets user set preference for primary natural language and languages to translate from and to.  Preferences naturalLanguage.  Preferences languageTranslateFrom."
	self removed.

! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'cr 3/17/2005 04:30'!
translateIt
	| |
	"Translate a passage of text and open its definition in a separate window.  Use the FreeTranslation.com server.  Requires internet access.  Default is English-> Spanish, but set it with the 'choose language' menu item."
	self remove.
! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'cr 3/17/2005 04:31'!
verifyWordSpelling
	| |
	"Look up a single word and inform the user if it was found.  Use the WordNet server.  Requires internet access.  Default is English, but set it like this
	Preferences setPreference: #naturalLanguage toValue: #Deutsch.
	"
	self removed.! !

!ParagraphEditor methodsFor: 'menu messages' stamp: 'cr 3/17/2005 04:32'!
wordDefinition
	| |
	"Look up a single word and open its definition in a separate window.  Use the WordNet server.  Requires internet access.  Default is English, but set it like this
	Preferences setPreference: #naturalLanguage toValue: #Portuguese.
	"
	self removed.
! !


!ParagraphEditor class methodsFor: 'class initialization' stamp: 'cr 3/17/2005 04:31'!
shiftedYellowButtonMenu
	"Answer the menu to be presented when the yellow button is pressed while the shift key is down"

	^ SelectionMenu fromArray: #(
		('set font... (k)'					offerFontMenu)
		('set style... (K)'					changeStyle)
		('set alignment...'				chooseAlignment)
		-
		('explain'						explain)
		('pretty print'					prettyPrint)
		('pretty print with color'		prettyPrintWithColor)
		('file it in (G)'					fileItIn)
		('tiles from it'					selectionAsTiles)
		('recognizer (r)'					recognizeCharacters)
		('spawn (o)'						spawn)
		-
		('definition of word'				wordDefinition)
		('verify spelling of word'		verifyWordSpelling)
"		('spell check it'					spellCheckIt)	"
		('translate it'					translateIt)
		('choose language'				languagePrefs)
		-
		('browse it (b)'					browseIt)
		('senders of it (n)'				sendersOfIt)
		('implementors of it (m)'		implementorsOfIt)
		('references to it (N)'			referencesToIt)
		-
		('selectors containing it (W)'		methodNamesContainingIt)
		('method strings with it (E)'		methodStringsContainingit)
		('method source with it'			methodSourceContainingIt)
		('class names containing it'		classNamesContainingIt)
		('class comments with it'		classCommentsContainingIt)
		('change sets with it'			browseChangeSetsWithSelector)
		-
		('save contents to file...'			saveContentsInFile)
		('send contents to printer'		sendContentsToPrinter)
		('printer setup'					printerSetup)
		-
		('special menu...'				presentSpecialMenu)
		('more...'						yellowButtonActivity))! !


!PasteUpMorph methodsFor: 'menu & halo' stamp: 'cr 3/16/2005 15:51'!
playfieldOptionsMenu
	"Answer an auxiliary menu with options specific to playfields -- too many to be housed in the main menu"

	| aMenu isWorld |
	isWorld _ self isWorldMorph.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	aMenu add: 'save on file...' action: #saveOnFile.
"	aMenu add: 'save as SqueakPage at url...' action: #saveOnURL."
	aMenu add: 'update all from resources' action: #updateAllFromResources.
	(self valueOfProperty: #classAndMethod) ifNotNil:
		[aMenu add: 'broadcast as documentation' action: #saveDocPane].
	aMenu add: 'round up strays' action: #roundUpStrays.
	aMenu balloonTextForLastItem:  'Bring back all objects whose current coordinates keep them from being visible, so that at least a portion of each of my interior objects can be seen.'.
	aMenu add: 'show all players' action: #showAllPlayers.
	aMenu balloonTextForLastItem:  'Make visible the viewers for all players which have user-written scripts in this playfield.'.
	aMenu add: 'hide all players' action: #hideAllPlayers.
	aMenu balloonTextForLastItem:  'Make invisible the viewers for all players in this playfield. This will save space before you publish this project'.


	aMenu addLine.
	aMenu add: 'shuffle contents' action: #shuffleSubmorphs.
	aMenu balloonTextForLastItem: 'Rearranges my contents in random order'.
	self griddingOn
		ifTrue: [aMenu add: 'turn gridding off' action: #griddingOnOff.
				aMenu add: (self gridVisible ifTrue: ['hide'] ifFalse: ['show']) , ' grid'
						action: #gridVisibleOnOff.
				aMenu add: 'set grid spacing...' action: #setGridSpec]
		ifFalse: [aMenu add: 'turn gridding on' action: #griddingOnOff].
	aMenu addLine.

	#(	(autoLineLayoutString	toggleAutoLineLayout
			'whether submorphs should automatically be laid out in lines')
		(indicateCursorString	toggleIndicateCursor
			'whether the "current" submorph should be indicated with a dark black border')
		(isPartsBinString		toggleIsPartsBin
			'whether dragging an object from the interior should produce a COPY of the object')
		(isOpenForDragNDropString	toggleDragNDrop
			'whether objects can be dropped into and dragged out of me')
		(mouseOverHalosString	toggleMouseOverHalos
			'whether objects should put up halos when the mouse is over them')
		(autoExpansionString	toggleAutomaticPhraseExpansion
			'whether tile phrases, dropped on me, should automatically sprout Scriptors around them')
		(originAtCenterString	toggleOriginAtCenter
			'whether the cartesian origin of the playfield should be at its lower-left corner or at the center of the playfield')
		(showThumbnailString	toggleAlwaysShowThumbnail
			'whether large objects should be represented by thumbnail miniatures of themselves')
		(fenceEnabledString	toggleFenceEnabled
			'whether moving objects should stop at the edge of their container')
		(batchPenTrailsString	toggleBatchPenTrails 
			'if true, detailed movement of pens between display updates is ignored.  Thus multiple line segments drawn within a script may not be seen individually.')

	) do:

			[:triplet |
				(isWorld and: [#(toggleAutoLineLayout toggleIndicateCursor toggleIsPartsBin toggleAlwaysShowThumbnail) includes: triplet second]) ifFalse:
					[aMenu addUpdating: triplet first action: triplet second.
					aMenu balloonTextForLastItem: triplet third]]. 

	aMenu addUpdating: #autoViewingString action: #toggleAutomaticViewing.
	aMenu balloonTextForLastItem:  'governs whether, when an object is touched inside me, a viewer should automatically be launched for it.'.

	((isWorld not or: [self backgroundSketch notNil]) or: [presenter isNil])
		ifTrue:
			[aMenu addLine].

	isWorld ifFalse:
		[aMenu add: 'set thumbnail height...' action: #setThumbnailHeight.
		aMenu balloonTextForLastItem: 'if currently showing thumbnails governs the standard height for them'.
		aMenu add: 'behave like a Holder' action: #becomeLikeAHolder.
		aMenu balloonTextForLastItem: 'Set properties to make this object nicely set up to hold frames of a scripted animation.'].

	self backgroundSketch ifNotNil:
		[aMenu add: 'delete background painting' action: #deleteBackgroundPainting.
		aMenu balloonTextForLastItem: 'delete the graphic that forms the background for this me.'].
	presenter ifNil:
		[aMenu add: 'make detachable' action: #makeDetachable.
		aMenu balloonTextForLastItem: 'Allow this area to be separately governed by its own controls.'].

	aMenu addLine.
	aMenu add: 'use standard texture' action: #setStandardTexture.
	aMenu balloonTextForLastItem: 'use a pale yellow-and-blue background texture here.'.
	aMenu add: 'make graph paper...' action: #makeGraphPaper.
	aMenu balloonTextForLastItem: 'Design your own graph paper and use it as the background texture here.'.
	aMenu addTitle: 'playfield options...'.

	^ aMenu
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'cr 3/17/2005 04:35'!
installAsActiveSubprojectIn: enclosingWorld at: newBounds titled: aString

	| window howToOpen tm boundsForWorld |

	howToOpen _ self embeddedProjectDisplayMode.	
				"#scaled may be the only one that works at the moment"

	submorphs do: [:ss | ss owner == nil ifTrue: [ss privateOwner: self]].
		"Transcript that was in outPointers and then got deleted."

	boundsForWorld _ howToOpen == #naked ifTrue: [newBounds] ifFalse: [bounds].
	worldState canvas: nil.
	worldState viewBox: boundsForWorld.

	self bounds: boundsForWorld.

	"self viewBox: Display boundingBox."
	"worldState handsDo: [:h | h initForEvents]."

	self installFlaps.

	"SystemWindow noteTopWindowIn: self."
	"self displayWorldSafely."

	howToOpen == #naked ifTrue: [
		enclosingWorld addMorphFront: self.
	].
	howToOpen == #window ifTrue: [
		window _ (NewWorldWindow labelled: aString) model: self.
		window addMorph: self frame: (0@0 extent: 1.0@1.0).
		window openInWorld: enclosingWorld.
	].
	howToOpen == #frame ifTrue: [
		window _ AlignmentMorph "Bob1" new
			minWidth: 100;
			minHeight: 100;
			borderWidth: 8;
			borderColor: Color green;
			bounds: newBounds.
		window addMorph: self.
		window openInWorld: enclosingWorld.
	].
	howToOpen == #scaled ifTrue: [
		self position: 0@0.
		window _ EmbeddedWorldBorderMorph new
			minWidth: 100;
			minHeight: 100;
			borderWidth: 8;
			borderColor: Color green;
			bounds: newBounds.
		tm _ BOBTransformationMorph new.
		window addMorph: tm.
		tm addMorph: self.
		window openInWorld: enclosingWorld.
		tm changeWorldBoundsToShow: bounds.
		self arrangeToStartSteppingIn: enclosingWorld.
		"tm scale: (tm width / self width min: tm height / self height) asFloat."
	].
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'cr 3/17/2005 04:34'!
installAsActiveSubprojectIn: enclosingWorld titled: aString

	| opt newWidth |

	opt _ self optimumExtentFromAuthor.
	(opt x > (enclosingWorld width * 0.7) or: 
			[opt y > (enclosingWorld height * 0.7)]) ifTrue: [
		newWidth _ enclosingWorld width // 2.
		opt _ newWidth @ (opt y * newWidth / opt x) truncated
	].
	^self 
		installAsActiveSubprojectIn: enclosingWorld 
		at: (enclosingWorld topLeft + (enclosingWorld extent - opt // 2) extent: opt) 
		titled: aString
! !

!PasteUpMorph methodsFor: 'project' stamp: 'cr 3/17/2005 04:36'!
releaseSqueakPages
	| |
	"If this world has a book with SqueakPages, then clear the SqueakPageCache"

	"no-op."! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'cr 3/17/2005 04:33'!
connectRemoteUser
	self removed.! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'cr 3/19/2005 19:20'!
disconnectAllRemoteUsers
	"Disconnect all remote hands and stop transmitting events."
"Remote hands are gone."

"	self world handsDo: [:h |
		(h isKindOf: RemoteHandMorph) 
			ifTrue: [h withdrawFromWorld]].
"! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'cr 3/17/2005 04:34'!
findAPreferencesPanel: evt
	"Locate a Preferences Panel, open it, and bring it to the front.  Create one if necessary"
	self removed.! !

!PasteUpMorph methodsFor: 'world menu' stamp: 'cr 3/17/2005 04:36'!
reportLocalAddress
	"Report the local host address of this computer."

	self removed.! !


!PasteUpMorph class methodsFor: 'project' stamp: 'cr 3/16/2005 15:47'!
newWorldTesting

	| world ex |

	ex _ 500@500.
	world _ PasteUpMorph newWorldForProject: nil.
	world extent: ex; color: Color orange.
	world openInWorld.
	world viewBox: (0@0 extent: ex).
"	BouncingAtomsMorph new openInWorld: world."

"-----

	| world window |
	world _ PasteUpMorph newWorldForProject: nil.
	world extent: 300@300; color: Color orange.
	world viewBox: (0@0 extent: 300@300).
	window _ (SystemWindow labelled: 'the new world') model: world.
	window color: Color orange.
	window addMorph: world frame: (0@0 extent: 1.0@1.0).
	window openInWorld.

---"
! !


!Player methodsFor: 'scripts-execution' stamp: 'cr 3/17/2005 04:38'!
stopProgramatically
	"stop running my ticking scripts -- called from running code"
	self instantiatedUserScriptsDo:
		[:aUserScript | aUserScript stopTicking].
"
	(costume renderedMorph isKindOf: SpeakerMorph)
		ifTrue: [costume renderedMorph stopSound]. " "turn off buffered speaker sound"
! !

!Player methodsFor: 'scripts-standard' stamp: 'cr 3/17/2005 04:38'!
loadSound: soundName

	self removed.! !


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'cr 3/20/2005 01:54'!
recognizeCharacters
	self removed.! !


!Preference methodsFor: 'local to project' stamp: 'cr 3/17/2005 04:42'!
toggleProjectLocalness
	"Toggle whether the preference should be held project-by-project or globally"

	localToProject _ localToProject not.
"
	PreferencesPanel allInstancesDo:
		[:aPanel | aPanel adjustProjectLocalEmphasisFor: name].
"! !


!Preferences class methodsFor: 'preferences panel' stamp: 'cr 3/17/2005 04:43'!
openFactoredPanelWithWidth: aWidth 
	"Open up a preferences panel of the given width"

	self removed.
! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'cr 3/20/2005 03:52'!
cmdGesturesEnabled
	"compiled programatically -- return hard-coded preference value"
	^ false! !


!ProcessBrowser class methodsFor: 'process control' stamp: 'cr 3/17/2005 04:45'!
nameAndRulesFor: aProcess 
	"Answer a nickname and two flags: allow-stop, and allow-debug"
	(aProcess priority = Processor timingPriority
			and: [aProcess suspendedContext receiver == Delay])
		ifTrue: [^ {'the timer interrupt watcher'. false. false}].
	^ [ aProcess caseOf: {
		[] -> [{'no process'. false. false}].
		[Smalltalk lowSpaceWatcherProcess] -> [{'the low space watcher'. false. false}].
		[WeakArray runningFinalizationProcess] -> [{'the WeakArray finalization process'. false. false}].
		[Processor activeProcess] -> [{'the UI process'. false. true}].
		[Processor backgroundProcess] -> [{'the idle process'. false. false}].
		[Sensor inputProcess] -> [{'the I/O process'. false. false}].
		[Sensor interruptWatcherProcess] -> [{'the user interrupt watcher'. false. false}].
		[Project uiProcess] -> [{'the inactive Morphic UI process'. false. false}].
"		[SoundPlayer playerProcess] -> [{'the Sound Player'. false. false}]."
		[ScheduledControllers ifNotNil: [ ScheduledControllers activeControllerProcess ] ] -> [{'the inactive MVC controller process'. false. true}].
		[CPUWatcher currentWatcherProcess] -> [{'the CPUWatcher' . false . false}]
	}
		 otherwise: [{aProcess suspendedContext asString. true. true}] ]
			ifError: [ :err :rcvr | {aProcess suspendedContext asString. true. true} ]! !


!Project methodsFor: 'menu messages' stamp: 'cr 3/22/2005 22:24'!
assureNavigatorPresenceMatchesPreference
	"Make sure that the current project conforms to the presence/absence of the navigator"

"no-ops: flaps are (incompletely) removed."

"
	| navigator navType wantIt |
	Smalltalk isMorphic ifFalse: [^ self].
	wantIt _  Preferences classicNavigatorEnabled and: [Preferences showProjectNavigator].
	navType _ ProjectNavigationMorph preferredNavigator.
	navigator _ world findA: navType.
	wantIt
		ifFalse:
			[navigator ifNotNil: [navigator delete]]
		ifTrue:
			[navigator isNil ifTrue: 
				[(navigator _ navType new)
					bottomLeft: world bottomLeft;
					openInWorld: world]]
"! !

!Project methodsFor: 'menu messages' stamp: 'cr 3/22/2005 22:27'!
finalEnterActions
	"Perform the final actions necessary as the receiver project is entered"

	| armsLengthCmd thingsToUnhibernate |

	self projectParameters 
		at: #projectsToBeDeleted 
		ifPresent: [ :projectsToBeDeleted |
			self removeParameter: #projectsToBeDeleted.
			projectsToBeDeleted do: [ :each | 
				Project deletingProject: each.
				each removeChangeSetIfPossible]].

	thingsToUnhibernate _ world valueOfProperty: #thingsToUnhibernate ifAbsent: [#()].
	thingsToUnhibernate do: [:each | each unhibernate].
	world removeProperty: #thingsToUnhibernate.

"	navType _ ProjectNavigationMorph preferredNavigator."
	armsLengthCmd _ self parameterAt: #armsLengthCmd ifAbsent: [nil].
"
	navigator _ world findA: navType.
	(Preferences classicNavigatorEnabled and: [Preferences showProjectNavigator and: [navigator isNil]]) ifTrue:
		[(navigator _ navType new)
			bottomLeft: world bottomLeft;
			openInWorld: world].

	navigator notNil & armsLengthCmd notNil ifTrue:
		[navigator color: Color lightBlue].
"
	armsLengthCmd notNil ifTrue:
		[Preferences showFlapsWhenPublishing
			ifFalse:
				[self flapsSuppressed: true.
				"navigator ifNotNil:	[navigator visible: false]"
				].
		armsLengthCmd openInWorld: world].
	Smalltalk isMorphic ifTrue:
		[world reformulateUpdatingMenus].

	WorldState addDeferredUIMessage: [self startResourceLoading].! !

!Project methodsFor: 'menu messages' stamp: 'cr 3/22/2005 22:29'!
finalExitActions

	"navigation morphs are gone."

"	| navigator |

	world isMorph ifTrue: [
		navigator _ world findA: ProjectNavigationMorph.
		navigator ifNotNil: [navigator retractIfAppropriate].
	].
"! !

!Project methodsFor: 'file in/out' stamp: 'cr 3/17/2005 02:02'!
saveAs
	"Forget where stored before, and store.  Will ask user where."

	nil inform: 'removed'.
! !

!Project methodsFor: 'file in/out' stamp: 'cr 3/17/2005 04:48'!
serverList
	"Take my list of server URLs and return a list of ServerDirectories to write on."
	^nil.! !

!Project methodsFor: 'file in/out' stamp: 'cr 3/17/2005 02:04'!
storeOnServerShowProgressOn: aMorphOrNil forgetURL: forget

	"Save to disk as an Export Segment.  Then put that file on the server I came from, as a new version.  Version is literal piece of file name.  Mime encoded and http encoded."

	nil inform: 'removed'.

"
	world setProperty: #optimumExtentFromAuthor toValue: world extent.
	self validateProjectNameIfOK: [
		self isCurrentProject ifTrue: [""exit, then do the command""
			forget
				ifTrue: [self forgetExistingURL]
				ifFalse: [urlList isEmptyOrNil ifTrue: [urlList _ parentProject urlList copy]].
			^self
				armsLengthCommand: #storeOnServerAssumingNameValid
				withDescription: 'Publishing'
		].
		self storeOnServerWithProgressInfoOn: aMorphOrNil.
	] fixTemps.
" ! !


!Project class methodsFor: 'squeaklet on server' stamp: 'cr 3/17/2005 04:50'!
fromUrl: urlString
	"Load the project, and make a thumbnail to it in the current project.  Replace the old one if necessary.
Project fromUrl: 'http://www.squeak.org/Squeak2.0/2.7segments/Squeak_Easy.pr.gz'.
"
	self removed.! !


!ProjectLoading class methodsFor: 'as yet unclassified' stamp: 'cr 3/17/2005 01:50'!
bestAccessToFileName: aFileName andDirectory: aDirectoryOrURL

	| localDir |

	((localDir _ Project squeakletDirectory) fileExists: aFileName) ifTrue: [
		^{localDir readOnlyFileNamed: aFileName. localDir}
	].
"
	(aDirectoryOrURL isKindOf: String) ifTrue: [
		^{(Project serverFileFromURL: aDirectoryOrURL) asStream. nil}
	].
"
	^{aDirectoryOrURL readOnlyFileNamed: aFileName. aDirectoryOrURL}
! !

!ProjectLoading class methodsFor: 'as yet unclassified' stamp: 'cr 3/19/2005 19:13'!
openName: aFileName stream: preStream fromDirectory: aDirectoryOrNil withProjectView: existingView
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved via the SmartRefStream mechanism, and open it in an appropriate Morphic world."
 	| morphOrList proj trusted localDir projStream archive mgr projectsToBeDeleted baseChangeSet |
	(preStream isNil or: [preStream size = 0]) ifTrue: [
		ProgressNotification  signal: '9999 about to enter project'.		"the hard part is over"
		^self inform: 
'It looks like a problem occurred while
getting this project. It may be temporary,
so you may want to try again,'
	].
	ProgressNotification signal: '2:fileSizeDetermined ',preStream size printString.
	preStream isZipArchive 
		ifTrue:[	archive _ ZipArchive new readFrom: preStream.
				projStream _ self projectStreamFromArchive: archive]
		ifFalse:[projStream _ preStream].
	trusted _ SecurityManager default positionToSecureContentsOf: projStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(preStream respondsTo: #close) ifTrue:[preStream close].
		^self]].

	localDir _ Project squeakletDirectory.
	aFileName ifNotNil: [
		(aDirectoryOrNil isNil or: [aDirectoryOrNil pathName ~= localDir pathName]) ifTrue: [
			localDir deleteFileNamed: aFileName.
			(localDir fileNamed: aFileName) 
				nextPutAll: preStream contents;
				close.
		].
	].
	morphOrList _ projStream asUnZippedStream.
	preStream sleep.		"if ftp, let the connection close"
	ProgressNotification  signal: '3:unzipped'.
	ResourceCollector current: ResourceCollector new.
	baseChangeSet _ Smalltalk changes.
	self useTempChangeSet.		"named zzTemp"
	"The actual reading happens here"
	[morphOrList _ morphOrList fileInObjectAndCode] ensure: [
				Smalltalk newChanges: baseChangeSet].
	mgr _ ResourceManager new initializeFrom: ResourceCollector current.
	mgr registerUnloadedResources.
	archive ifNotNil:[mgr preLoadFromArchive: archive cacheName: aFileName].
	(preStream respondsTo: #close) ifTrue:[preStream close].
	ResourceCollector current: nil.
	ProgressNotification  signal: '4:filedIn'.
	ProgressNotification  signal: '9999 about to enter project'.		"the hard part is over"
	(morphOrList isKindOf: ImageSegment) ifTrue: [
		proj _ morphOrList arrayOfRoots 
			detect: [:mm | mm class == Project] 
			ifNone: [^self inform: 'No project found in this file'].
		proj resourceManager: mgr.
		"proj versionFrom: preStream."
		proj lastDirectory: aDirectoryOrNil.
		CurrentProjectRefactoring currentBeParentTo: proj.
		projectsToBeDeleted _ OrderedCollection new.
		existingView ifNil: [
			Smalltalk isMorphic ifTrue: [
				proj createViewIfAppropriate.
			] ifFalse: [
				ChangeSorter allChangeSets add: proj changeSet.
				ProjectView openAndEnter: proj.
				"Note: in MVC we get no further than the above"
			].
		] ifNotNil: [
			(existingView project isKindOf: DiskProxy) ifFalse: [
				existingView project changeSet name: ChangeSet defaultName.
				projectsToBeDeleted add: existingView project.
			].
			(existingView owner isKindOf: SystemWindow) ifTrue: [
				existingView owner model: proj
			].
			existingView project: proj.
		].
		ChangeSorter allChangeSets add: proj changeSet.
		Project current projectParameters 
			at: #deleteWhenEnteringNewProject 
			ifPresent: [ :ignored | 
				projectsToBeDeleted add: Project current.
				Project current removeParameter: #deleteWhenEnteringNewProject.
			].
		projectsToBeDeleted isEmpty ifFalse: [
			proj projectParameters 
				at: #projectsToBeDeleted 
				put: projectsToBeDeleted.
		].
		^ ProjectEntryNotification signal: proj
	].

"
	(morphOrList isKindOf: SqueakPage) ifTrue: [
		morphOrList _ morphOrList contentsMorph
	].
"
	(morphOrList isKindOf: PasteUpMorph) ifFalse: [
		^ self inform: 'This is not a PasteUpMorph or exported Project.'
	].
	(Project newMorphicOn: morphOrList) enter
! !


!ResourceManager methodsFor: 'loading' stamp: 'cr 3/20/2005 01:10'!
startDownload
	"Start downloading unloaded resources"
	self stopDownload.
	unloaded isEmpty ifTrue:[^self].
	self loadCachedResources.

	self error: 'resource downloading removed.'.
"
	unloaded isEmpty ifTrue:[^self].
	stopFlag _ false.
	stopSemaphore _ Semaphore new.
	loaderProcess _ [self loaderProcess] newProcess.
	loaderProcess priority: Processor lowIOPriority.
	loaderProcess resume.
"! !


!ScriptInstantiation methodsFor: 'status control' stamp: 'cr 3/20/2005 01:36'!
presentScriptStatusPopUp
	"Put up a menu of status alternatives and carry out the request"

	| aMenu reply standardStati  |
	"NB; the keyStroke branch commented out temporarily until keystrokes can actually be passed along to the user's scripting code"

	standardStati _ #(normal paused ticking mouseDown mouseStillDown mouseUp mouseEnter mouseLeave mouseEnterDragging mouseLeaveDragging opening closing "keyStroke").
	aMenu _ SelectionMenu labelList:  #(
		'normal'		" -- run when called"		
		'paused' 		"ready to run all the time"
		'ticking'		"run all the time"
		'mouseDown'	"run when mouse goes down on me"
		'mouseStillDown'	"while mouse still down"
		'mouseUp'		"when mouse comes back up"
		'mouseEnter'	"when mouse enters my bounds, button up"
		'mouseLeave'	"when mouse exits my bounds, button up"
		'mouseEnterDragging'	"when mouse enters my bounds, button down"
		'mouseLeaveDragging'	"when mouse exits my bounds, button down"
		'opening'	"when I am being opened"
		'closing'	"when I am being closed"
	"	'keyStroke'	run when user hits a key"
		'what do these mean?'
		'apply my status to all siblings'
		)
		lines: #(1 3 6 10 12 13)
		selections: (standardStati, #(explainStatusAlternatives assignStatusToAllSiblings)).

	reply _ aMenu startUpWithCaption: 'When should this script run?'.
	(reply == #keyStroke) ifTrue: [^ self inform: 'user-scripted fielding
of keystrokes is not
yet available.'].

	reply == #explainStatusAlternatives ifTrue: [^ self explainStatusAlternatives].
	reply == #assignStatusToAllSiblings ifTrue: [^ self assignStatusToAllSiblings].
	reply ifNotNil: 
		[self status: reply.  "Gets event handlers fixed up"
"
		reply == #paused ifTrue:
			[m _ player costume.
			(m isKindOf: SpeakerMorph) ifTrue: [m stopSound]].
"
		self updateAllStatusMorphs]! !


!SimpleButtonMorph methodsFor: 'fileIn/Out' stamp: 'cr 3/16/2005 15:52'!
objectForDataStream: refStrm
	"I am about to be written on an object file.  If I send a message to a BookMorph, it would be bad to write that object out.  Create and write out a URLMorph instead."

	self error: 'feature removed.'.! !


!SketchMorph methodsFor: 'drawing' stamp: 'cr 3/16/2005 15:29'!
drawInterpolatedImage: aForm on: aCanvas
	"Draw the given form onto the canvas using the Balloon 3D engine"
	| engine |
	engine _ nil. "(B3DRenderEngine defaultForPlatformOn: aCanvas form)."
	engine == nil ifTrue:[
		self useInterpolation: false.
		^self generateRotatedForm].
! !


!BookPageThumbnailMorph methodsFor: 'fileIn/Out' stamp: 'cr 3/17/2005 03:26'!
objectsInMemory
	"See if page or bookMorph need to be brought in from a server."
	self removed.! !


!String methodsFor: 'converting' stamp: 'cr 3/20/2005 01:47'!
asUrl
	"convert to a Url"
	"'http://www.cc.gatech.edu/' asUrl"
	"msw://chaos.resnet.gatech.edu:9000/' asUrl"
"	^Url absoluteFromText: self"
	self error: 'feature removed.'! !


!StringHolder methodsFor: 'message list menu' stamp: 'cr 3/20/2005 01:48'!
fetchDocPane
	"Look on servers to see if there is documentation pane for the selected message. Take into account the current update number.  If not, ask the user if she wants to create one."


	self removed.
! !


!Browser methodsFor: 'class functions' stamp: 'cr 3/17/2005 03:27'!
shiftedClassListMenu: aMenu
	"Set up the menu to apply to the receiver's class list when the shift key is down"

	^ aMenu addList: #(
			-
			('unsent methods'			browseUnusedMethods	'browse all methods defined by this class that have no senders')
			('unreferenced inst vars'	showUnreferencedInstVars	'show a list of all instance variables that are not referenced in methods')
			('unreferenced class vars'	showUnreferencedClassVars	'show a list of all class variables that are not referenced in methods')
			('subclass template'			makeNewSubclass		'put a template into the code pane for defining of a subclass of this class')
			-
			('sample instance'			makeSampleInstance		'give me a sample instance of this class, if possible')
			('inspect instances'			inspectInstances			'open an inspector on all the extant instances of this class')
			('inspect subinstances'		inspectSubInstances		'open an inspector on all the extant instances of this class and of all of its subclasses')
			-
"			('fetch documentation'		fetchClassDocPane		'once, and maybe again someday, fetch up-to-date documentation for this class from the Squeak documentation repository') "
			('add all meths to current chgs'		addAllMethodsToCurrentChangeSet
																'place all the methods defined by this class into the current change set')
			('create inst var accessors'	createInstVarAccessors	'compile instance-variable access methods for any instance variables that do not yet have them')
			-
			('more...'					offerUnshiftedClassListMenu	'return to the standard class-list menu'))! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'cr 3/16/2005 15:41'!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"

	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	Smalltalk isMorphic
		ifTrue:
			[aMenu title: 'Change Set'.
			aMenu addStayUpItemSpecial]
		ifFalse:
			[aMenu title: 'Change Set:
' , myChangeSet name].

	aMenu add: 'make changes go to me (m)' action: #newCurrent.
	aMenu addLine.
	aMenu add: 'new change set... (n)' action: #newSet.
	aMenu add: 'find...(f)' action: #findCngSet.
	aMenu add: 'show category... (s)' action:  #chooseChangeSetCategory.
	aMenu balloonTextForLastItem:
'Lets you choose which change sets should be listed in this change sorter'.
	aMenu add: 'select change set...' action: #chooseCngSet.
	aMenu addLine.
	aMenu add: 'rename change set (r)' action: #rename.
	aMenu add: 'file out (o)' action: #fileOut.
"	aMenu add: 'mail to list' action: #mailOut."
	aMenu add: 'browse methods (b)' action: #browseChangeSet.
	aMenu add: 'browse change set (B)' action: #openChangeSetBrowser.
	aMenu addLine.
	parent
		ifNotNil: 
			[aMenu add: 'copy all to other side (c)' action: #copyAllToOther.
			aMenu add: 'submerge into other side' action: #submergeIntoOtherSide.
			aMenu add: 'subtract other side (-)' action: #subtractOtherSide.
			aMenu addLine].
	myChangeSet hasPreamble
		ifTrue: 
			[aMenu add: 'edit preamble (p)' action: #addPreamble.
			aMenu add: 'remove preamble' action: #removePreamble]
		ifFalse: [aMenu add: 'add preamble (p)' action: #addPreamble].
	myChangeSet hasPostscript
		ifTrue: 
			[aMenu add: 'edit postscript...' action: #editPostscript.
			aMenu add: 'remove postscript' action: #removePostscript]
		ifFalse: [aMenu add: 'add postscript...' action: #editPostscript].
	aMenu addLine.

	aMenu add: 'category functions...' action: #offerCategorySubmenu.
	aMenu balloonTextForLastItem:
'Various commands relating to change-set-categories'.
	aMenu addLine.


	aMenu add: 'destroy change set (x)' action: #remove.
	aMenu addLine.
	aMenu add: 'more...' action: #offerShiftedChangeSetMenu.
	^ aMenu! !


!Debugger methodsFor: 'context stack menu' stamp: 'cr 3/16/2005 15:49'!
mailOutBugReport
	"Compose a useful bug report showing the state of the process as well as vital image statistics as suggested by Chris Norton - 
'Squeak could pre-fill the bug form with lots of vital, but
oft-repeated, information like what is the image version, last update
number, VM version, platform, available RAM, author...'

and address it to the list with the appropriate subject prefix."

	nil inform: 'feature removed'.
! !


!FileList methodsFor: 'initialization' stamp: 'cr 3/16/2005 19:36'!
modelWakeUp
	"User has entered or expanded the window -- reopen any remote connection."
"
	(directory isKindOf: ServerDirectory) 
		ifTrue: [directory wakeUp] " "It would be good to implement a null method wakeUp on the root of directory"! !

!FileList methodsFor: 'volume list and pattern' stamp: 'cr 3/17/2005 03:40'!
listForPattern: pat
	"Make the list be those file names which match the pattern."

	| sizePad newList |
	newList _ (self entriesMatching: pat) asSortedCollection: self sortBlock.
	sizePad _ (newList inject: 0 into: [:mx :entry | mx max: (entry at: 5)])
					asStringWithCommas size - 1.
	newList _ newList collect: [ :e | self fileNameFormattedFrom: e sizePad: sizePad ].

	^ newList asArray! !

!FileList methodsFor: 'file list' stamp: 'cr 3/17/2005 03:36'!
fileListIndex: anInteger
	"Select the file name having the given index, and display its contents."

	| item name |
	self okToChange ifFalse: [^ self].
	listIndex := anInteger.
	listIndex = 0 
		ifTrue: [fileName := nil]
		ifFalse:
			[item := self fileNameFromFormattedItem: (list at: anInteger).
			(item endsWith: self folderString)
				ifTrue:
					["remove [...] folder string and open the folder"
					name := item copyFrom: 1 to: item size - self folderString size.
					listIndex := 0.
					brevityState := #FileList.
					self addPath: name.
					name first = $^
						ifTrue: [self removed.]
						ifFalse: [volListIndex = 1 ifTrue: [name _ name, directory slash].
							self directory: (directory directoryNamed: name)]]
				ifFalse: [fileName := item]].  "open the file selected"

	brevityState := #needToGetBrief.
	self changed: #fileListIndex.
	self changed: #contents.
	self updateButtonRow! !

!FileList methodsFor: 'obsolete methods' stamp: 'cr 3/16/2005 19:16'!
openModelintoAlice
	"If a Wonderland exists, load this model into it as an actor.  If it doesn't, make one first"
	nil inform: 'removed'.
! !

!FileList methodsFor: 'to be transformed in registration' stamp: 'cr 3/17/2005 03:41'!
putUpdate: fullFileName
	"Put this file out as an Update on the servers."
	self removed.! !

!FileList methodsFor: 'to be transformed in registration' stamp: 'cr 3/17/2005 03:43'!
volumeMenu: aMenu
	^ aMenu labels:
'recent...
add server...
remove server (removed)...
delete directory...'
		lines: # (1 3)
		selections: #(recentDirs askServerInfo removed deleteDirectory)
! !

!FileList methodsFor: 'private' stamp: 'cr 3/17/2005 03:42'!
readContentsBrief: brevityFlag
	"Read the contents of the receiver's selected file, unless it is too long, in which case show just the first 5000 characters. Don't create a file if it doesn't already exist."
	| f fileSize first5000 |

"
	brevityFlag ifTrue: [
		(directory isKindOf: ServerDirectory) ifTrue: [^ self readServerBrief]].
"
	f _ directory oldFileOrNoneNamed: self fullName.
	f ifNil: [^ 'For some reason, this file cannot be read'].
	(brevityFlag not or: [(fileSize _ f size) <= 100000]) ifTrue:
		[contents _ f contentsOfEntireFile.
		brevityState _ #fullFile.   "don't change till actually read"
		^ contents].

	"if brevityFlag is true, don't display long files when first selected"
	first5000 _ f next: 5000.
	f close.
	contents _ 'File ''', fileName, ''' is ', fileSize printString, ' bytes long.
You may use the ''get'' command to read the entire file.

Here are the first 5000 characters...
------------------------------------------
', first5000 , '
------------------------------------------
... end of the first 5000 characters.'.
	brevityState _ #briefFile.   "don't change till actually read"
	^ contents.
! !


!FileList2 methodsFor: 'as yet unclassified' stamp: 'cr 3/17/2005 03:45'!
initialDirectoryList

	| dirList |
	dirList _ (FileDirectory on: '') directoryNames collect: [ :each |
		FileDirectoryWrapper with: (FileDirectory on: each) name: each model: self].
	dirList isEmpty ifTrue:[
		dirList _ Array with: (FileDirectoryWrapper 
			with: FileDirectory default 
			name: FileDirectory default localName 
			model: self)].
"
	dirList _ dirList,(
		ServerDirectory serverNames collect: [ :n | 
			dir _ ServerDirectory serverNamed: n.
			nameToShow _ n.
			(dir directoryWrapperClass with: dir name: nameToShow model: self)
				balloonText: dir realUrl
		]
	).
"
	^dirList! !

!FileList2 methodsFor: 'as yet unclassified' stamp: 'cr 3/17/2005 03:46'!
limitedSuperSwikiDirectoryList

	| dirList |

	dirList _ OrderedCollection new.
"
	ServerDirectory serverNames do: [ :n | 
		dir _ ServerDirectory serverNamed: n.
		dir isProjectSwiki ifTrue: [
			nameToShow _ n.
			dirList add: ((dir directoryWrapperClass with: dir name: nameToShow model: self)
				balloonText: dir realUrl)
		].
	].
	ServerDirectory localProjectDirectories do: [ :each |
		dirList add: (FileDirectoryWrapper with: each name: each localName model: self)
	].
"
	(dirList anySatisfy: [:each | each withoutListWrapper acceptsUploads])
		ifFalse: [dirList add: (FileDirectoryWrapper with: FileDirectory default name: FileDirectory default localName model: self)].
	^dirList! !


!FileList2 class methodsFor: 'blue ui' stamp: 'cr 3/17/2005 03:50'!
morphicViewProjectLoader2InWorld: aWorld reallyLoad: aBoolean dirFilterType: aSymbol

	| window aFileList buttons treePane textColor1 fileListPane pane2a pane2b treeExtent filesExtent |

"	window _ AlignmentMorphBob1 newColumn."
	window _ AlignmentMorph newColumn.		"Probably won't work but worth a shot."

	window hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	textColor1 _ Color r: 0.742 g: 0.839 b: 1.0.
	aFileList _ self new directory: FileDirectory default.
	aFileList 
		optionalButtonSpecs: aFileList servicesForProjectLoader;
		fileSelectionBlock: (
			aSymbol == #limitedSuperSwikiDirectoryList ifTrue: [
				MessageSend receiver: self selector: #projectOnlySelectionMethod:
			] ifFalse: [
				self projectOnlySelectionBlock
			]
		);
		"dirSelectionBlock: self hideSqueakletDirectoryBlock;"
		modalView: window.
	window
		setProperty: #FileList toValue: aFileList;
		wrapCentering: #center; cellPositioning: #topCenter;
		borderWidth: 4;
		borderColor: (Color r: 0.355 g: 0.516 b: 1.0);
		useRoundedCorners.
	buttons _ #('OK' 'Cancel') collect: [ :each |
		self blueButtonText: each textColor: textColor1 inWindow: window
	].
	aWorld width < 800 ifTrue: [
		treeExtent _ 150@300.
		filesExtent _ 350@300.
	] ifFalse: [
		treeExtent _ 250@300.
		filesExtent _ 350@300.
	].
	(treePane _ aFileList morphicDirectoryTreePaneFiltered: aSymbol)
		extent: treeExtent; 
		retractable: false;
		borderWidth: 0.
	fileListPane _ aFileList morphicFileListPane 
		extent: filesExtent; 
		retractable: false;
		borderWidth: 0.
	window
		addARow: {
			window fancyText: 'Load A Project' ofSize: 21 color: textColor1
		};
		addARowCentered: {
			buttons first. 
			(Morph new extent: 30@5) color: Color transparent. 
			buttons second
		};
		addARow: {
			window fancyText: 'Please select a project' ofSize: 21 color: Color blue
		};
		addARow: {
			(window inAColumn: {(pane2a _ window inARow: {window inAColumn: {treePane}}) 
				useRoundedCorners; layoutInset: 6}) layoutInset: 10.
			(window inAColumn: {(pane2b _ window inARow: {window inAColumn: {fileListPane}}) 
				useRoundedCorners; layoutInset: 6}) layoutInset: 10.
		}.
	window fullBounds.
	window fillWithRamp: self blueRamp1 oriented: 0.65.
	pane2a fillWithRamp: self blueRamp3 oriented: (0.7 @ 0.35).
	pane2b fillWithRamp: self blueRamp3 oriented: (0.7 @ 0.35).
	buttons do: [ :each |
		each fillWithRamp: self blueRamp2 oriented: (0.75 @ 0).
	].
	buttons first 
		on: #mouseUp 
		send: (aBoolean ifTrue: [#okHitForProjectLoader] ifFalse: [#okHit])
		to: aFileList.
	buttons second on: #mouseUp send: #cancelHit to: aFileList.
	aFileList postOpen.
	window position: aWorld topLeft + (aWorld extent - window extent // 2).
	window adoptPaneColor: (Color r: 0.548 g: 0.677 b: 1.0).
	^ window openInWorld: aWorld.! !

!FileList2 class methodsFor: 'blue ui' stamp: 'cr 3/17/2005 03:53'!
morphicViewProjectSaverFor: aProject
"
(FileList2 morphicViewProjectSaverFor: Project current) openInWorld
"
	| window aFileList buttons treePane pane2 textColor1 option treeExtent buttonData buttonRow |

	textColor1 _ Color r: 0.742 g: 0.839 b: 1.0.
	aFileList _ self new directory: FileDirectory default.
	aFileList dirSelectionBlock: self hideSqueakletDirectoryBlock.
"	window _ AlignmentMorphBob1 newColumn."
	window _ AlignmentMorph newColumn.		"Once again, dangerous!!"
	window hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aFileList modalView: window.
	window
		setProperty: #FileList toValue: aFileList;
		wrapCentering: #center; cellPositioning: #topCenter;
		borderWidth: 4;
		borderColor: (Color r: 0.355 g: 0.516 b: 1.0);
		useRoundedCorners.
	buttonData _ Preferences enableLocalSave
		ifTrue: [#( 
			('Save' okHit 'Save in the place specified below, and in the 
	Squeaklets folder on your local disk') 
			('Save on local disk only' saveLocalOnlyHit 'saves in the Squeaklets folder')
			('Cancel' cancelHit 'return without saving') 
			)]
		ifFalse: [#( 
			('Save' okHit 'Save in the place specified below, and in the 
	Squeaklets folder on your local disk') 
			('Cancel' cancelHit 'return without saving') 
			)].
	buttons _ buttonData collect: [ :each |
		(self blueButtonText: each first textColor: textColor1 inWindow: window)
			setBalloonText: each third;
			hResizing: #shrinkWrap;
			on: #mouseUp send: each second to: aFileList
	].
	option _ aProject world 
		valueOfProperty: #SuperSwikiPublishOptions 
		ifAbsent: [#initialDirectoryList].
	aProject world removeProperty: #SuperSwikiPublishOptions.

	World height < 500 ifTrue: [
		treeExtent _ 350@150.
	] ifFalse: [
		treeExtent _ 350@300.
	].

	(treePane _ aFileList morphicDirectoryTreePaneFiltered: option) 
		extent: treeExtent; 
		retractable: false;
		borderWidth: 0.
	window
		addARowCentered: {
			window fancyText: 'Publish This Project' ofSize: 21 color: textColor1
		}.
	buttonRow _ OrderedCollection new.
	buttons do: [:button | buttonRow add: button] separatedBy: [buttonRow add: ((Morph new extent: 30@5) color: Color transparent)].

"	addARowCentered: {
			buttons first. 
			(Morph new extent: 30@5) color: Color transparent. 
			buttons second.
			(Morph new extent: 30@5) color: Color transparent. 
			buttons third
		};"
	window
		addARowCentered: buttonRow;
		addARowCentered: { (window inAColumn: {(ProjectViewMorph on: aProject) lock}) layoutInset: 4};
		addARowCentered: {
			window fancyText: 'Please select a folder' ofSize: 21 color: Color blue
		};
		addARow: {
			(
				window inAColumn: {
					(pane2 _ window inARow: {window inAColumn: {treePane}}) 
						useRoundedCorners; layoutInset: 6
				}
			) layoutInset: 10
		}.
	window fullBounds.
	window fillWithRamp: self blueRamp1 oriented: 0.65.
	pane2 fillWithRamp: self blueRamp3 oriented: (0.7 @ 0.35).
	buttons do: [ :each |
		each fillWithRamp: self blueRamp2 oriented: (0.75 @ 0).
	].
	window setProperty: #morphicLayerNumber toValue: 11.
	aFileList postOpen.
	window adoptPaneColor: (Color r: 0.548 g: 0.677 b: 1.0).
	^ window ! !


!PluggableFileList methodsFor: 'file list menu' stamp: 'cr 3/17/2005 04:40'!
listForPattern: pat
	"Make the list be those file names which match the pattern."
	| entries sizePad newList allFiles |
	entries _ directory entries select: fileFilterBlock.
	sizePad _ (entries inject: 0 into: [:mx :entry | mx max: (entry at: 5)])
					asStringWithCommas size - 1.

	newList _ (SortedCollection new: 30) sortBlock: self sortBlock.

	allFiles _ pat = '*'.
	entries do:
		[:entry | "<dirflag><name><creationTime><modificationTime><fileSize>"
		(allFiles or: [entry isDirectory or: [pat match: entry first]]) ifTrue:
			[newList add: entry]].

	newList _ newList collect: [ :e | self fileNameFormattedFrom: e sizePad: sizePad ].

"
	volList size = 1 ifTrue:
		[""Include known servers along with other desktop volumes" "
		^ newList asArray ,
		(ServerDirectory serverNames collect: [:n | '^' , n , self folderString])].
"
	newFiles _ OrderedCollection new.
	^ newList asArray.! !


!SystemDictionary methodsFor: 'browsing' stamp: 'cr 5/25/2004 00:55'!
browseAllMethodsReferencingObsoleteClasses
	"Create and schedule a message browser on each method that refers to
	an obsolete class."

	self 
		browseMessageList: (self allMethodsReferencingObsoleteClasses) asSortedCollection
		name: 'Methods Holding Garbage Classes'.
! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'cr 5/25/2004 02:11'!
allMethodsReferencingObsoleteClasses
	"Return the list of methods which reference an obsolete class."
	| obs result literals obsRefs |
	obs := self obsoleteClasses asSet.
	result := OrderedCollection new.

	self allBehaviorsDo: [ :class |
		class selectors do: [ :sel |
			literals := (class lookupSelector: sel) literals.
			obsRefs := literals select: [ :lit | lit isVariableBinding and: [obs includes: lit value]].
			
			obsRefs size = 0
				ifFalse: [result add: (MethodReference new setStandardClass: class methodSymbol: sel)].
		].
	].

	^result.
! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'cr 5/27/2004 23:41'!
allSenderChainsFor: methodRefSet
	"Return a collection containing all of the referenced methods, plus their senders,
      plus THEIR senders, and so on."

	| oldSet newSet |
	oldSet := methodRefSet asSet.
	newSet := nil.

	[oldSet = newSet] whileFalse: [
		newSet := Set new.
		oldSet do: [ :item | newSet add: item; addAll: (self allCallsOn: item methodSymbol)].
	].

	^newSet	! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'BG 11/1/2003 14:06'!
allSentMessagesWithout: classesAndMessagesPair
	"Answer the set of selectors which are sent somewhere in the system, computed in the absence of the supplied classes and messages."
	| sent absentClasses absentSelectors literals hasMenuFromArray |
	sent _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	absentSelectors _ classesAndMessagesPair second.
	Cursor execute showWhile: 
		[self classNames do: 
			[:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{(self at: cName). (self at: cName) class}]) do:
				[:cl | (absentSelectors isEmpty
						ifTrue: [cl selectors]
						ifFalse: [cl selectors copyWithoutAll: absentSelectors]) do: 
					[:sel | "Include all sels, but not if sent by self"
                         literals := (cl compiledMethodAt: sel) literals.
                         hasMenuFromArray :=
                          (literals includes: #addList:) | (literals includes: #fromArray:) .
					 literals  do: 
						[:m | 
						(m isMemberOf: Symbol) ifTrue:  "might be sent"
							[m == sel ifFalse: [sent add: m]].
						(m isMemberOf: Array) ifTrue:  "might be performed"
							[m do: [:x | (x isMemberOf: Symbol) ifTrue:
								             [x == sel ifFalse: [sent add: x]].
                                               (hasMenuFromArray and: [x isMemberOf: Array])
                                                 ifTrue: [x do: [:y | (y isMemberOf: Symbol) ifTrue:
								             [y == sel ifFalse: [sent add: y]].]]
                                 ]       ].
   
]]]].
		"The following may be sent without being in any literal frame"
		1 to: self specialSelectorSize do: 
			[:index | 
			sent add: (self specialSelectorAt: index)]].
	Smalltalk presumedSentMessages do: [:sel | sent add: sel].
	^ sent! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'cr 5/26/2004 23:51'!
allUnimplementedCallRefs
	"Just like allUnimplementedCalls except it returns a MethodReference for each call."

	| aStream all  |
	all _ self allImplementedMessages.
	aStream _ WriteStream on: (Array new: 50).
	Cursor execute showWhile:
		[self allBehaviorsDo:
			[:cl |
			 cl selectorsDo:
				[:sel | (cl compiledMethodAt: sel) messages do:
					[:m | (all includes: m)
							ifFalse: [
								aStream nextPut: (MethodReference new 
													setStandardClass: cl methodSymbol: sel)]]]]].

	^aStream contents! !

!SystemDictionary methodsFor: 'retrieving' stamp: 'cr 5/28/2004 00:28'!
closedSetOfBrokenMethods
	"Return the collection of all methods which send unimplemented messages AND have
	 no senders except from within that set."

	| brokenRefs callers |
	brokenRefs := Smalltalk allUnimplementedCallRefs asSet.

	^brokenRefs select: [ :sel |
		callers := self allCallsOn: sel methodSymbol.
		(callers reject: [ :mref | brokenRefs includes: mref]) isEmpty
	].
	! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 11/1/2003 22:51'!
discard3D
	"Smalltalk discard3D"
	"Discard 3D Support."
	self discardWonderland.
	Smalltalk removeKey: #B3DEngineConstants ifAbsent: [].
	Smalltalk at: #InterpolatingImageMorph ifPresent:[:cls| cls removeFromSystem].
	SystemOrganization removeCategoriesMatching: 'Graphics-FXBlt'.
	SystemOrganization removeCategoriesMatching: 'Graphics-External'.
	SystemOrganization removeCategoriesMatching: 'Balloon3D-*'.
	SystemOrganization removeCategoriesMatching: 'Graphics-Tools-*'.
	Color removeSelector: #asB3DColor.
	Form removeSelector: #asTexture.
	(Smalltalk at: #Morph) removeSelector: #asTexture.
	FileList removeSelector: #open3DSFile.
	Point removeSelector: #@.
	Smalltalk at: #BalloonCanvas ifPresent:[:cc| cc removeSelector: #render:].
	Stream removeSelector: #asVRMLStream.
     (Smalltalk includesKey: #DataStream)
         ifTrue: [(Smalltalk at: #DataStream) initialize]! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'Jon 8/24/2001 13:31'!
discardGenie
	"Discard Genie support."

	SystemOrganization removeCategoriesMatching: 'Genie-Engine'.
	SystemOrganization removeCategoriesMatching: 'Genie-UI'.
	SystemOrganization removeCategoriesMatching: 'Genie-Integration'.! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 11/2/2003 23:18'!
discardIRC
	"Smalltalk discardIRC"
	SystemOrganization removeCategoriesMatching: 'Network-IRC Chat'.
	(Smalltalk at: #TheWorldMenu) compile:'openIRC self inform:''IRC is not present'' '.! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 10/29/2003 08:26'!
discardMorphic
	"Discard Morphic.
Updated for 2.8 TPR"

   "Smalltalk discardMorphic"

	| subs |
	"Check that we are in an MVC Project and that there are no Morphic Projects
		or WorldMorphViews."
	(Smalltalk at: #Flaps) clobberFlapTabList.
	Smalltalk discardFlash.
	Smalltalk discardTrueType.
	subs _ OrderedCollection new.
	(Smalltalk at: #Morph) allSubclassesWithLevelDo: [:c :i | subs addFirst: c]
		startingLevel: 0.
	subs do: [:c | c removeFromSystem].
	Smalltalk removeClassNamed: #CornerRounder.
	Smalltalk removeKey: #BalloonEngineConstants ifAbsent: [].
	SystemOrganization removeCategoriesMatching: 'Balloon-*'.
	SystemOrganization removeCategoriesMatching: 'Morphic-*'.
	SystemOrganization removeSystemCategory: 'Graphics-Transformations'.
	SystemOrganization removeSystemCategory: 'ST80-Morphic'.
	ScriptingSystem _ nil.
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 3/27/2005 11:54'!
discardOddsAndEnds
	"This method throws out lots of classes that are not frequently used."
	"Smalltalk discardOddsAndEnds"

"	SystemOrganization removeSystemCategory: 'System-Serial Port'. "
	SystemOrganization removeSystemCategory: 'ST80-Symbols'.
	"SystemOrganization removeSystemCategory: 'Tools-File Contents Browser'. "
"	SystemOrganization removeSystemCategory: 'Tools-Explorer'."
	"SystemOrganization removeSystemCategory: 'System-Digital Signatures'."
	"SystemOrganization removeSystemCategory: 'System-Archives'."
	SystemOrganization removeSystemCategory: 'Framework-Download'.
	SystemOrganization removeSystemCategory: 'System-Download'.
     SystemOrganization removeCategoriesMatching: 'XML-Parser'.
	Smalltalk removeClassNamed: #PreferencesPanel.

	Form removeSelector: #edit.
	Smalltalk at: #FormView ifPresent:
		[:c | c compile: 'defaultControllerClass  ^ NoController'
			classified: 'controller access'].
	Smalltalk removeClassNamed: #FormEditorView.
	Smalltalk removeClassNamed: #FormEditor.
	SystemOrganization removeSystemCategory: 'ST80-Paths'.

	"bit editor (remove Form editor first):"
	Form removeSelector: #bitEdit.
	Form removeSelector: #bitEditAt:scale:.
	StrikeFont removeSelector: #edit:.
	Smalltalk removeClassNamed: #FormButtonCache.
	Smalltalk removeClassNamed: #FormMenuController.
	Smalltalk removeClassNamed: #FormMenuView.
	Smalltalk removeClassNamed: #BitEditor.

	"inspector for Dictionaries of Forms"
	Dictionary removeSelector: #inspectFormsWithLabel:.
	SystemDictionary removeSelector: #viewImageImports.
	ScreenController removeSelector: #viewImageImports.
	Smalltalk removeClassNamed: #FormHolderView.
	Smalltalk removeClassNamed: #FormInspectView.

	"experimental hand-drawn character recoginizer:"
	ParagraphEditor removeSelector: #recognizeCharacters.
	ParagraphEditor removeSelector: #recognizer:.
	ParagraphEditor removeSelector: #recognizeCharactersWhileMouseIn:.
	Smalltalk removeClassNamed: #CharRecog.

	"experimental updating object viewer:"
	Object removeSelector: #evaluate:wheneverChangeIn:.
	Smalltalk removeClassNamed: #ObjectViewer.
	Smalltalk removeClassNamed: #ObjectTracer.

	"miscellaneous classes:"
	Smalltalk removeClassNamed: #DriveACar.
	Smalltalk removeClassNamed: #EventRecorder.
	Smalltalk removeClassNamed: #FindTheLight.
	Smalltalk removeClassNamed: #PluggableTest.
	Smalltalk removeClassNamed: #SystemMonitor.
	Smalltalk removeClassNamed: #DocLibrary.

	Smalltalk removeClassNamed: #ObjectExplorerWrapper.
	Smalltalk removeClassNamed: #LinkedMessageSet.
	Smalltalk removeClassNamed: #ObjectExplorer.
	Smalltalk removeClassNamed: #PackageBrowser.
	Smalltalk removeClassNamed: #AbstractHierarchicalList.
"	Smalltalk removeClassNamed: #HtmlFileStream. "
	Smalltalk removeClassNamed: #FXGrafPort.
	Smalltalk removeClassNamed: #FXBlt.

	Smalltalk at: #SampledSound ifPresent: [:c |c initialize].
"	#(Helvetica Palatino Courier ComicBold ComicPlain) do:
		[:k | TextConstants removeKey: k ifAbsent: []]. "

Preferences setButtonFontTo:	(StrikeFont familyName: #NewYork size: 12).



! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'Jon 8/24/2001 14:00'!
discardSUnit
	"Discard SUnit support."

	SystemOrganization removeCategoriesMatching: 'SUnit-Framework'.
	SystemOrganization removeCategoriesMatching: 'SUnit-Interface'.
	SystemOrganization removeCategoriesMatching: 'SUnit-Tests'.
	SystemOrganization removeCategoriesMatching: 'SCAN-Tests'! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 10/29/2003 08:49'!
discardWonderland
	"Smalltalk discardWonderland"
	"Discard 3D Support."
	Smalltalk at: #Wonderland ifPresent:[:cls| cls removeActorPrototypesFromSystem].
	Smalltalk removeKey: #WonderlandConstants ifAbsent: [].
	Smalltalk removeKey: #AliceConstants ifAbsent: [].
	SystemOrganization removeCategoriesMatching: 'Balloon3D-Wonderland*'.
	SystemOrganization removeCategoriesMatching: 'Balloon3D-Alice*'.
	SystemOrganization removeCategoriesMatching: 'Balloon3D-Pooh*'.
	SystemOrganization removeCategoriesMatching: 'Balloon3D-UserObjects'.
	Smalltalk at: #VRMLWonderlandBuilder ifPresent:[:cls| cls removeFromSystem].
	FileList removeSelector: #openVRMLFile.
	(Smalltalk at: #HaloMorph) compile: 'addPoohHandle: ignored ^self'.! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 10/29/2003 00:10'!
lastRemoval			"Smalltalk lastRemoval"

	 | oldDicts newDicts |

	"Some explicit removals - add unwanted methods keeping other methods."
	#(abandonSources printSpaceAnalysis)
		do: [:each | self class removeSelector: each].

	"Get rid of all unsent methods."
	[self removeAllUnSentMessages > 0] whileTrue.

	"Shrink method dictionaries."
	Smalltalk garbageCollect.
	oldDicts _ MethodDictionary allInstances.
	newDicts _ Array new: oldDicts size.
	oldDicts withIndexDo: [:d :index | 
		newDicts at: index put: d rehashWithoutBecome.
	].
	oldDicts elementsExchangeIdentityWith: newDicts.
	oldDicts _ newDicts _ nil.

"	Smalltalk allClassesDo: [:c | c zapOrganization]. "
	SystemOrganization _ nil.

	Smalltalk changes initialize! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 5/30/2004 17:31'!
majorShrink    
	"This has been split into majorShrinkStart and majorShrinkFinish."
	self halt: 'Should not use.  Instead, use majorShrinkStart and majorShrinkFinish.'
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 11/3/2003 22:35'!
majorShrinkClassesToLeave

	^#(True False ReadOnlyVariableBinding SystemOrganizer ClassOrganizer View Switch Button EndOfStream ValueHolder)! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 6/5/2004 19:34'!
majorShrinkClassesToZap

	^#(BDFFontReader 
		InstanceBrowser 
		Lexicon 
		TarArchiveMember 
		CRLookupResult
		"PluggableDictionary"
		" PluggableSet "
		MimeConverter
		QuotedPrintableMimeConverter
		RFC2047MimeConverter
		"AbstractLauncher"   "Needed for standalone apps. --CR"
		"AutoStart"			 "Ditto."
		AcornFileDirectory
		 " AssertionFailure "
		"CachedHTTPRequest "
		CachingCodeLoader
		CodeLoader
		EToyVectorVocabulary
		EToyVocabulary
          FileList2
		FTPConnectionException
		FullVocabulary
	"	HTTPClient
		HTTPLoader
		HTTPRequest "
		HtmlFileStream
		MacFileDirectory
		MacHFSPlusFileDirectory
		PluginHTTPRequest
		SUnitNameResolver
		ScreenedVocabulary
		ScriptNameType
		SoundType
		StringType
		SymbolListType
		TestCase
		TestFailure
		TestResource
		TestResult
		TestRunner
		TestSuite
		TestViaMethodCall
		TextSqkPageLink
		TextSqkProjectLink
	"	TextURL "
		UnknownType
		Verifier
		VerifierOfProperty
		Vocabulary
		BooleanType
		ButtonPhaseType
		ColorType
		DataType
		GraphicType
		MenuType
		NumberType
		PlayerType

		"And now, some extras.  (These will be useless without the rest of the system anyway.)"
		AntColonyTurtle
		ChangeListForProjects
		DiffusionTurtle
		ExceptionTester
		ExternalStructureInspector
	  	FileDirectoryTests
		FileList2ModalDialogsTest
		FileListTest 
	  	IntegerDigitLogicTestCase
		IntervalTestCase 
	  	MidiPrimTester 
		MorphObjectOut 
		SUnitDelay 
		SlimeMoldTurtle
	  	StarSqueakPatch
		DummyToolWorkingWithFileList
		SmalltalkEnvironment
	  	TermiteTurtle
		TimeTestCase
		TreeTurtle
		WeakMessageSendTestCase
	  	WriteStreamTest
		StarSqueakTurtle
		TarArchive
		)! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 5/24/2004 23:49'!
majorShrinkFinish    
	"Undertake a major shrinkage of the image.
	
	 This stage just removes all the unset methods.  It is intended to be called after
	 majorShrinkStart.
	"

	| oldDicts newDicts classesToLeave |

	classesToLeave := Smalltalk majorShrinkClassesToLeave.
	[Smalltalk removeAllUnSentMessages > 0] whileTrue: [
		Smalltalk unusedClasses do: [:c |
			(classesToLeave includes: c)
				ifFalse: [
					Transcript cr; show: 'Removing class: ', c.
					(Smalltalk at: c) removeFromSystem]].
		Transcript cr; show: 'Done removing classes...'].
    Preferences removeObsoleteInstances.
    self discardDiscards. 

     Transcript cr; show: 'Done removing unsent methods...'; cr.
	SystemOrganization removeEmptyCategories.
	Smalltalk allClassesDo: [:c | c compactOrganization].
     Transcript show: 'Class Organization compaced.'; cr.

	Smalltalk garbageCollect.

	'Rehashing method dictionaries . . .'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: MethodDictionary instanceCount
		during: [:bar |
			oldDicts _ MethodDictionary allInstances.
			newDicts _ Array new: oldDicts size.
			oldDicts withIndexDo: [:d :index | 
				bar value: index.
				newDicts at: index put: d rehashWithoutBecome.
			].
			oldDicts elementsExchangeIdentityWith: newDicts.
		].
	oldDicts _ newDicts _ nil.
	Project rebuildAllProjects.
	Smalltalk changes initialize.

	"seems to take more than one try to gc all the weak refs in SymbolTable"

	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 3/23/2005 01:01'!
postMajorShrink
   | oldDicts  newDicts |
	SystemOrganization removeEmptyCategories.
"	Smalltalk allClassesDo: [:c | c compactOrganization]. "
	Smalltalk garbageCollect.

	'Rehashing method dictionaries . . .'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: MethodDictionary instanceCount
		during: [:bar |
			oldDicts _ MethodDictionary allInstances.
			newDicts _ Array new: oldDicts size.
			oldDicts withIndexDo: [:d :index | 
				bar value: index.
				newDicts at: index put: d rehashWithoutBecome.
			].
			oldDicts elementsExchangeIdentityWith: newDicts.
		].
	oldDicts _ newDicts _ nil.
"
	Project rebuildAllProjects.
	Smalltalk changes initialize.
"

	"seems to take more than one try to gc all the weak refs in SymbolTable"

	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 10/28/2003 16:56'!
preMajorShrink
	"Smalltalk preMajorShrink"

	"You should already be in an MVC project before you run this...
	This gets rid of all the other projects, and makes the current MVC one the top project."
    References removeKey: #Car ifAbsent: [];
                  removeKey: #Wheel ifAbsent: [].
	Smalltalk zapAllOtherProjects.
	ProjectHistory currentHistory initialize.
	Smalltalk garbageCollect.
	Project rebuildAllProjects.
! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 11/8/2003 13:53'!
presumedSentMessages   | sent |
"Smalltalk presumedSentMessages"

	"The following should be preserved for doIts, etc"
	sent _ IdentitySet new.
	#( rehashWithoutBecome compactSymbolTable rebuildAllProjects
		browseAllSelect: printSpaceAnalysis lastRemoval
		scrollBarValue: scrollBarMenuButtonPressed: 
		withSelectionFrom:  to: removeClassNamed: instVarNamed:put:
          maximumSize: redButtonMenu:redButtonMessages:
		dragon: hilberts: mandala: web test3 factorial tinyBenchmarks benchFib
		newDepth: restoreAfter: forgetDoIts zapAllMethods obsoleteClasses
		removeAllUnSentMessages abandonSources removeUnreferencedKeys
		reclaimDependents zapOrganization condenseChanges browseObsoleteReferences
		subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
    " subclass creation: "
		variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		variableWordSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		weakSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		methodsFor:stamp: methodsFor:stamp:prior: instanceVariableNames:
		startTimerInterruptWatcher unusedClasses
		widthOfString: widthOfString:from:to: clipHeight clipHeight: 
		clipWidth clipWidth: clipX clipX: clipY clipY: 
          newDay:monthIndex:year: abandon pixelForValueAt:put:
          magnifyBy: replaceColor:withColor: dotOfSize:  "DisplayScreen> " fullBoundingBox
          originFromUser:
	" StrikeFont> "
		maxAscii minAscii maxWidth firstIndent:
          restIndent: rightIndent: newFontArray: fontArray:
          readStrikeFont2Family:  familySizeFace writeAsStrike2Named:
	"  Paragraph  "
		compositionRectangle: 
   " Form: these methods are meeded for gif creation "
		colorReduced colorsUsed
   " protocol from Pen class: "
		inkBrush simplePressurePen testMouseTracking testTabletTracking
   " two methods that are hidden from the method tracer "
		method: preamble:
   " convenience methods in True and False: "
		and:and: and:and:and: and:and:and:and:
		or:or: or:or:or: or:or:or:or:
  " mics "
     	pairsDo: font:  
  " ExternalEvent class: "
		registerClient:
     ) do:
		[:sel | sent add: sel].
	"The following may be sent by perform: in dispatchOnChar..."
	(ParagraphEditor classPool at: #CmdActions) asSet do:
		[:sel | sent add: sel].
	(ParagraphEditor classPool at: #ShiftCmdActions) asSet do:
		[:sel | sent add: sel].
 Smalltalk majorShrinkClassesToLeave do:
  [:symbol | sent addAll: (Smalltalk at: symbol) selectors;
                 addAll: (Smalltalk at: symbol) class selectors.].
	^ sent! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 10/28/2003 22:11'!
removeAllUnSentMessages   "Smalltalk removeAllUnSentMessages"
	"[Smalltalk unusedClasses do: [:c | (Smalltalk at: c) removeFromSystem].
		Smalltalk removeAllUnSentMessages > 0] whileTrue." 

	"Remove all implementations of unsent messages."
	| sels n |
	sels _ self allUnSentMessages.

	"The following should be preserved for doIts, etc"
	#(
		rehashWithoutBecome compactSymbolTable rebuildAllProjects	"needed even after #majorShrink is pulled"
			
		browseAllSelect: printSpaceAnalysis lastRemoval
		scrollBarValue: scrollBarMenuButtonPressed: 
		withSelectionFrom:  to: removeClassNamed:
		dragon: hilberts: mandala: web test3 factorial tinyBenchmarks benchFib
		newDepth: restoreAfter: forgetDoIts zapAllMethods obsoleteClasses
		removeAllUnSentMessages condenseChanges condenseSources abandonSources removeUnreferencedKeys postMajorShrink offerShiftedClassListMenu offerUnshiftedClassListMenu
         font1 font2 font3 font4
		reclaimDependents zapOrganization condenseChanges browseObsoleteReferences
		subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		methodsFor:stamp: methodsFor:stamp:prior: instanceVariableNames:
		startTimerInterruptWatcher unusedClasses) do:
		[:sel | sels remove: sel ifAbsent: []].
	"The following may be sent by perform: in dispatchOnChar..."
	(ParagraphEditor classPool at: #CmdActions) asSet do:
		[:sel | sels remove: sel ifAbsent: []].
	(ParagraphEditor classPool at: #ShiftCmdActions) asSet do:
		[:sel | sels remove: sel ifAbsent: []].
	sels size = 0 ifTrue: [^ 0].

	n _ 0. Smalltalk allBehaviorsDo: [:x | n _ n+1].
	'Removing ', sels size printString , ' messages . . .'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: n
		during:
		[:bar |
		n _ 0.
		self allBehaviorsDo:
			[:class | bar value: (n _ n+1).
			sels do:
				[:sel | class removeSelectorSimply: sel]]].
	^ sels size! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'cr 5/26/2004 21:39'!
removeZombieMethods
	"Remove all methods which reference obsolete classes.  DANGER!! This can do serious damage
	 to your image.  It works here because somebody has already gone through the image and
	 removed the obsolete references from the classes we still care about."

	self allMethodsReferencingObsoleteClasses
		do: [ :methRef |	methRef actualClass removeSelector: methRef methodSymbol].

! !

!SystemDictionary methodsFor: 'shrinking' stamp: 'BG 11/1/2003 11:59'!
zapAllOtherProjects 
	"Smalltalk zapAllOtherProjects"
"Note: as of this writing, the only reliable way to get rid of all but the current project is te execute the following, one line at a time...
		Smalltalk zapAllOtherProjects.
		ProjectHistory currentHistory initialize.
		Smalltalk garbageCollect.
		Project rebuildAllProjects.
"

	
	Project allInstancesDo: [:p | p setParent: nil].
	Project current setParent: Project current.
	Project current isMorphic ifTrue: [ScheduledControllers _ nil].
	(Smalltalk includesKey: #TheWorldMenu)
        ifTrue: [(Smalltalk at: #TheWorldMenu) allInstancesDo: [:m | 1 to: m class instSize do: [:i | m instVarAt: i put: nil]]].
	ChangeSorter classPool at: #AllChangeSets put: nil.
	Project classPool at: #AllProjects put: nil.
	ProjectHistory currentHistory initialize.
	ChangeSorter initialize.
	Project rebuildAllProjects.  "Does a GC"
	Project allProjects size > 1 ifTrue: [Project allProjects inspect]! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/23/2005 21:50'!
bloatByClass
	"Compile a dictionary matching classes to the total size of its indexes."

	| dict sum |
	dict := IdentityDictionary new.	
	Object allSubclasses do: [ :cl | 
		sum := 0.
		cl allInstancesDo: [ :i | sum := sum + i guesstimatedSize].
		dict at: cl put: sum.
	].

	^dict.
		
! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/23/2005 01:08'!
morphicShrink
	
	"Shrink, leaving Morphic intact."

    References removeKey: #Car ifAbsent: [];
                  removeKey: #Wheel ifAbsent: [].

	ProjectViewMorph allInstancesDo:
		[:m | (m hasProperty: #deleteWorldsOfSqueak) ifTrue:
			[Project deletingProject: m project. m delete]].
	Project rebuildAllProjects.
	ScriptingSystem spaceReclaimed.

(self at: #Wonderland) removeActorPrototypesFromSystem.
Player abandonUnnecessaryUniclasses.
Player freeUnreferencedSubclasses.

self discardWonderland.
self discard3D.

self discardSoundAndSpeech.
self discardSoundSynthesis.
self discardFlash.
self discardVMConstruction.
self discardFFI.
self discardGenie.
self discardSUnit.
self discardIRC.
self discardOddsAndEnds.
self discardNetworking.

self removeClassesAndStuff.
self removeSelectorsAndStuff.


"Various bits of cruft.  You have no idea how look these took to track down!!"
DataStream initialize.
TheWorldMenu unregisterOpenCommand: 'VMMaker'.
Vocabulary initialize.
Flaps clobberFlapTabList.
ExternalSettings unregisterObsoleteClients.
Smalltalk forgetDoIts.
Utilities emptyScrapsBook.

Smalltalk postMajorShrink.
! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 23:11'!
objectsReferencingObsoleteClasses
	| result targets subInstances count |
	result := IdentitySet new.
	targets := Smalltalk obsoleteClasses asIdentitySet.

	subInstances := WeakArray withAll: Object allSubInstances.
	Smalltalk garbageCollect.
	'Searching...'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: subInstances size
		during: [:bar |
			count := 0.
			subInstances do: [ :si | 
				(si referencesOneOf: targets) ifTrue: [result add: si].
				count := count + 1.
				bar value: count.
			].
		].

	^result.
! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 22:52'!
removeClassesAndStuff

	"More removals.  Pardon the mess."

	"These are the ones I had to pick out myself."

Preferences disable: #showSharedFlaps.

Utilities class removeSelector: #broadcastUpdatesFrom:to:except:.
FileStream class removeSelector: #httpPostDocument:args:.

Utilities class removeSelector: #broadcastUpdatesFrom:to:except:.
FileStream class removeSelector: #httpPostDocument:args:.

Project class removeSelector: #serverFileFromURL:.
BookMorph removeSelector: #saveOnUrlPage:.
BookMorph removeSelector: #saveIndexOfOnly:.
Smalltalk removeClassNamed: #AudioChatGUI.
Project removeSelector: #storeOnServer.
Project removeSelector: #storeOnServerAssumingNameValid.
Project removeSelector: #storeOnServerWithProgressInfo.
Project removeSelector: #storeOnServerWithProgressInfoOn:.

Smalltalk removeClassNamed: #BlobMPEGMorph. 
Smalltalk removeClassNamed: #MPEGMoviePlayerMorph.
Smalltalk removeClassNamed: #MPEGPlayer.
Smalltalk removeClassNamed: #MPEGDisplayMorph.
Smalltalk removeClassNamed: #JPEGMovieFile.
Smalltalk removeClassNamed: #MPEGFile.
Smalltalk removeClassNamed: #MoviePlayerMorph.

SystemOrganization removeCategoriesMatching: 'Morphic-Remote'.

Morph removeSelector: #saveOnURL.
Project removeSelector: #storeOnServerInnards.
ResourceCollector removeSelector: #writeResourceForm:fromLocator:.
PaintBoxMorph removeSelector: #init4.
ImageReadWriter class removeSelector: #formFromServerFile.

SystemOrganization removeCategoriesMatching: 'Morphic-Experimental'.
SystemOrganization removeCategoriesMatching: 'StarSqueak-*'.


SystemOrganization removeCategoriesMatching: 'Morphic-Imported'.
"SystemOrganization removeCategoriesMatching: 'Balloon-*'."

SmartRefStream removeCategory: 'conversion'.

SystemOrganization removeCategoriesMatching: 'Morphic-Games-Chess'.

SystemOrganization removeCategoriesMatching: 'Morphic-UserObjects'.

Smalltalk removeClassNamed: #EToyHierarchicalTextGizmo.
Smalltalk removeClassNamed: #EToyHierarchicalTextMorph.

SystemOrganization removeCategoriesMatching: 'Morphic-GeeMail'.
Morph removeSelector: #printSpecs.
Smalltalk removeClassNamed: #ProjectNavigationMorph.

"Remove AlignmentMorphBob1 from the heirarchy."
AlignmentMorph subclass: #ThreadNavigationMorph
	instanceVariableNames: 'listOfPages currentIndex loadedProject '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Navigators'.
ThreadNavigationMorph compileAll.

Smalltalk removeClassNamed: #EToyListenerMorph.
Smalltalk removeClassNamed: #EToyMorphsWelcomeMorph.
Smalltalk removeClassNamed: #EToyFridgeMorph.
SystemOrganization removeCategoriesMatching: 'Morphic-Collaborative'.

Smalltalk removeClassNamed: #SoundEventMorph.

Smalltalk removeClassNamed: #StoryboardBookMorph.
Smalltalk removeClassNamed: #ZASMCameraMarkMorph.
Smalltalk removeClassNamed: #ZASMStepsMorph.
Smalltalk removeClassNamed: #ZASMScriptMorph.
Smalltalk removeClassNamed: #ZoomAndScrollControllerMorph.
Smalltalk removeClassNamed: #ZoomAndScrollMorph.

Smalltalk removeClassNamed: #KidNavigationMorph.
Smalltalk removeClassNamed: #NebraskaNavigationMorph.! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/23/2005 21:15'!
removeMoreClassesAndStuff
	
	SystemOrganization removeCategoriesMatching: 'Morphic-Components Built'.

	NullEncoder category: 'Morphic-Salvaged'.	
	FlattenEncoder category: 'Morphic-Salvaged'.
	SystemOrganization removeCategoriesMatching: 'Morphic-Postscript*'.


	String removeSelector: #asPostscript.
	Object removeSelector: #propertyList.
	BookMorph removeSelector: #asPostscript.
	Morph removeSelector: #asPostscriptPrintJob.
	Morph removeSelector: #asPostscript.
	Morph removeSelector: #asEPS.

	Smalltalk removeClassNamed: #CachingCanvas.
	Smalltalk removeClassNamed: #ClassRepresentativeMorph.
	Smalltalk removeClassNamed: #DumberMenuMorph.
	Smalltalk removeClassNamed: #EtoyUpdatingThreePhaseButtonMorph.
	Smalltalk removeClassNamed: #GraphicalDictionaryMenu.
	Smalltalk removeClassNamed: #MorphExample.
	Smalltalk removeClassNamed: #MouseOverMorph.
	Smalltalk removeClassNamed: #PhraseWrapperMorph.
	Smalltalk removeClassNamed: #PlayWithMe1.
	Smalltalk removeClassNamed: #PluggableTextAttribute.
	Smalltalk removeClassNamed: #PrintComponent.

	Smalltalk removeClassNamed: #ScrollingToolHolder.
	PaintBoxMorph prototype stampHolder: nil.

	Smalltalk removeClassNamed: #SerialPort.
	Smalltalk removeClassNamed: #SoundReadoutTile.
	Smalltalk removeClassNamed: #SuperSwikiDirectoryWrapper.
	Smalltalk removeClassNamed: #SyntaxTestMethods.
	Smalltalk removeClassNamed: #TestBalloonFont.
	Smalltalk removeClassNamed: #TransformationB2Morph.
	Smalltalk removeClassNamed: #UpdatingBooleanStringMorph.
"	Smalltalk removeClassNamed: #ZLibWriteStream."
! !

!SystemDictionary methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 22:37'!
removeSelectorsAndStuff

	"These are mostly selectors that keep zombie classes alive."


Smalltalk removeClassNamed: #AbstractMediaEventMorph.

AutoStart class removeSelector: #checkForPluginUpdate.
AutoStart class removeSelector: #checkForUpdates.
BDFFontReader class removeSelector: #downloadFonts.
BitBlt class removeSelector: #exampleOne.
BookMorph removeSelector: #forgetURLs.
BookMorph removeSelector: #fromRemoteStream:.
BookMorph removeSelector: #saveIndexOnURL.
BookPageThumbnailMorph removeSelector: #justDroppedIntoPianoRoll:event:.
BookPageThumbnailMorph removeSelector: #objectForDataStream:.
BookPageThumbnailMorph removeSelector: #objectsInMemory.
Browser removeSelector: #fetchClassDocPane.
ChangeSet removeSelector: #buildMessageForMailOutWithUser:.
Color removeSelector: #encodeForRemoteCanvas.
Point removeSelector: #encodeForRemoteCanvas.
Rectangle removeSelector: #encodeForRemoteCanvas.
Dictionary removeSelector: #explorerContents.
EventRecorderMorph removeSelector: #addVoiceControls.
FileDirectory removeSelector: #eToyBaseFolderSpec.
FileDirectory removeSelector: #eToyBaseFolderSpec:.
FileDirectory removeSelector: #eToyUserList.
FileDirectory removeSelector: #eToyUserListUrl.
FileDirectory removeSelector: #eToyUserListUrl:.
FileDirectory removeSelector: #hasEToyUserList.
FileList removeSelector: #loadCRDictionary.
FileList removeSelector: #loadCRDisplayProperties.
FileList removeSelector: #removeServer.
FileList2 removeSelector: #limitedSuperSwikiPublishDirectoryList.
FileList2 removeSelector: #publishingServers.
FileList2 class removeSelector: #morphicViewGeneralLoaderInWorld:.
FileStream class removeSelector: #httpPostMultipart:args:.
ImageReadWriter class removeSelector: #formFromServerFile:.
MorphicEvent class removeSelector: #fromStringArray:.
KeyboardEvent removeSelector: #decodeFromStringArray:.
MouseButtonEvent removeSelector: #decodeFromStringArray:.
MouseMoveEvent removeSelector: #decodeFromStringArray:.
KeyboardEvent removeSelector: #encodedAsStringArray.
Morph removeSelector: #openAButtonPropertySheet.
Morph removeSelector: #openAPropertySheet.
Morph removeSelector: #openATextPropertySheet.
Morph removeSelector: #reserveURL:.
Morph removeSelector: #saveOnURL:.
Morph removeSelector: #saveOnURLbasic.
MouseButtonEvent removeSelector: #encodedAsStringArray.
MouseMoveEvent removeSelector: #encodedAsStringArray.

Smalltalk removeClassNamed: #MovieClipEndMorph.
Smalltalk removeClassNamed: #MovieClipStartMorph.
Smalltalk removeClassNamed: #MovieFrameSyncMorph.
Smalltalk removeClassNamed: #ObjectOut.
Smalltalk removeClassNamed: #MorphObjectOut.

PasteUpMorph removeSelector: #connectRemoteUserWithName:picture:andIPAddress:.
Preferences class removeSelector: #preferencesControlPanel.

Smalltalk removeClassNamed: #ProgressMorph.

Project removeSelector: #tellAFriend:.
Project removeSelector: #tellAFriend.
Project removeSelector: #validateProjectNameIfOK:.
Project class removeSelector: #serverDirectoryFromURL:.

Smalltalk removeClassNamed: #ProjectSorterMorph.
Smalltalk removeClassNamed: #RemoteHandMorph.

ResourceManager removeSelector: #loaderProcess.

ResourceManager class removeSelector: #cacheResource:stream:.
SequenceableCollection removeSelector: #explorerContents.
Set removeSelector: #explorerContents.
"SoundEventMorph removeSelector: #releaseCachedState."

Smalltalk removeClassNamed: #SoundTile.
Smalltalk removeClassNamed: #SoundType.

StandardScriptingSystem removeSelector: #cleanupsForRelease.
StandardScriptingSystem removeSelector: #prepareForExternalReleaseNamed:.
String removeSelector: #replaceHtmlCharRefs.
SystemDictionary removeSelector: #makeExternalRelease.
SystemDictionary removeSelector: #makeSqueaklandRelease.
SystemVersion class removeSelector: #check:andRequestPluginUpdate:.
TTSampleStringMorph removeSelector: #loadFromURL:.
TextMorphEditor removeSelector: #recognizeCharactersWhileMouseIn:.
UserInputEvent removeSelector: #encodedAsStringArray.
Utilities class removeSelector: #objectStrmFromUpdates:.
PaintBoxMorph removeSelector: #loadColorChooser.
Utilities class removeSelector: #readServerUpdatesSaveLocally:updateImage:.
Utilities class removeSelector: #readNextUpdateFromServer.
SystemVersion class removeSelector: #checkAndApplyUpdates:.
Utilities class removeSelector: #updateFromServerThroughUpdateNumber:.
Utilities class removeSelector: #readServerUpdatesThrough:saveLocally:updateImage:.
Utilities class removeSelector: #readServer:special:updatesThrough:saveLocally:updateImage:.
Utilities class removeSelector: #retrieveUrls:ontoQueue:withWaitSema:.
Utilities class removeSelector: #serverUrls.
Utilities class removeSelector: #newUpdatesOn:special:throughNumber:.

Smalltalk removeClassNamed: #ProgressMorph.
! !


!TTSampleStringMorph methodsFor: 'menus' stamp: 'cr 3/20/2005 01:52'!
loadFromURL
	"Allow the user to change the text in a crude way"
	self removed.! !


!TextMorph methodsFor: 'menu' stamp: 'cr 3/17/2005 04:05'!
changeTextColor
	"Change the color of the receiver -- triggered, e.g. from a menu"

	self removed.! !


!TextMorphEditor methodsFor: 'events' stamp: 'cr 3/20/2005 01:57'!
recognizeCharacters
	"Recognize hand-written characters and put them into the receiving pane.  Invokes Alan's character recognizer."
	self removed.! !


!TextURL methodsFor: 'as yet unclassified' stamp: 'cr 3/16/2005 19:27'!
actOnClickFor: anObject
	"Do what you can with this URL.  Later a web browser."

	| m |

	(url beginsWith: 'sqPr://') ifTrue: [
		ProjectLoading thumbnailFromUrl: (url copyFrom: 8 to: url size).
		^self		"should not get here, but what the heck"
	].
	"if it's a web browser, tell it to jump"
	anObject isWebBrowser
		ifTrue: [anObject jumpToUrl: url. ^ true]
		ifFalse: [((anObject respondsTo: #model) and: [anObject model isWebBrowser])
				ifTrue: [anObject model jumpToUrl: url. ^ true]].

		"if it's a morph, see if it is contained in a web browser"
		(anObject isKindOf: Morph) ifTrue: [
			m _ anObject.
			[ m ~= nil ] whileTrue: [
				(m isWebBrowser) ifTrue: [
					m  jumpToUrl: url.
					^true ].
				(m hasProperty: #webBrowserView) ifTrue: [
					m model jumpToUrl: url.
					^true ].
				m _ m owner. ]
		].

	"no browser in sight.  ask if we should start a new browser"
	self inform: 'no browser'.

	^ true! !


!TheWorldMenu methodsFor: 'commands' stamp: 'cr 3/16/2005 15:50'!
openEmail
	"open an email interface"

	self notify: 'removed' ! !

!TheWorldMenu methodsFor: 'construction' stamp: 'cr 3/20/2005 01:59'!
helpMenu
        "Build the help menu for the world."
        | screenCtrl genieEnabledString |

        screenCtrl _ ScreenController new.
	   genieEnabledString _ World currentHand isGenieEnabled ifTrue: ['disable'] ifFalse: ['enable'].
        ^ self fillIn: (self menu: 'help...') from:
        {
                {'about this system...'. {Smalltalk. #aboutThisSystem}. 'current version information.'}.
                {'update code from server'. {Utilities. #updateFromServer}. 'load latest code updates via the internet'}.
                {'preferences...'. {Preferences. #openPreferencesInspector}. 'view and change various options.'}.
			 {'set language...' . {Project. #chooseNaturalLanguage}. 'choose the language in which tiles should be displayed.'} .
                nil.
                {genieEnabledString , ' genie'. {World currentHand. #switchGenieEnabled}. genieEnabledString , ' gesture recognizer for the world''s current hand'}.
"
                {'genie gesture dictionaries'. {CRDictionary. #openInstanceBrowserMorph}. 'edit or inspect gesture dictionaries'.}.
                {'choose genie text dictionary'. {CRDictionary. #chooseTextDictionary}. 'select the dictionary used for text input'.}.
                {'genie display properties'. {CRDisplayProperties. #openInstanceBrowserMorph}. 'edit or inspect display properies'.}.
"
                nil.
                {'command-key help'. { Utilities . #openCommandKeyHelp}. 'summary of keyboard shortcuts.'}.
                {'world menu help'. { self . #worldMenuHelp}. 'helps find menu items buried in submenus.'}.
                        "{'info about flaps' . { Utilities . #explainFlaps}. 'describes how to enable and use flaps.'}."
                {'font size summary' . { Utilities . #fontSizeSummary}.  'summary of names and sizes of available fonts.'}.
                {'useful expressions' . { Utilities . #openStandardWorkspace}. 'a window full of useful expressions.'}.
			 {'annotation setup...' . { Preferences . #editAnnotations}. 'Click here to get a little window that will allow you to specify which types of annotations, in which order, you wish to see in the annotation panes of browsers and other tools'}.
			nil.
                {'graphical imports' . { Smalltalk . #viewImageImports}.  'view the global repository called ImageImports; you can easily import external graphics into ImageImports via the FileList'}.
                {'standard graphics library' . { ScriptingSystem . #inspectFormDictionary}.  'lets you view and change the system''s standard library of graphics.'}.
                nil.
                {'telemorphic...' . {self. #remoteDo}.  'commands for doing multi-machine "telemorphic" experiments'}.
                {#soundEnablingString . { Preferences . #toggleSoundEnabling}. 'turning sound off will completely disable Squeak''s use of sound.'}.
                {'definition for...' . { Utilities . #lookUpDefinition}.  'if connected to the internet, use this to look up the definition of an English word.'}.
                nil.

                {'set author initials...' . { screenCtrl . #setAuthorInitials }. 'supply initials to be used to identify the author of code and other content.'}.
                {'vm statistics' . { screenCtrl . #vmStatistics}.  'obtain some intriguing data about the vm.'}.
			  nil.
			  {'purge undo records' . { CommandHistory . #resetAllHistory }. 'save space by removing all the undo information remembered in all projects.'}.
                {'space left' . { screenCtrl . #garbageCollect}. 'perform a full garbage-collection and report how many bytes of space remain in the image.'}.
        }

! !

!TheWorldMenu methodsFor: 'construction' stamp: 'cr 3/17/2005 02:01'!
projectMenu
	"Build the project menu for the world."
	| menu |

	self flag: #bob0302.

	menu _ self menu: 'projects...'.
	self fillIn: menu from: { 
"
		{ 'save on server (also makes a local copy)' . { #myProject . #storeOnServer } }.
		{ 'save to a different server' . { #myProject . #saveAs } }.
		{ 'save project on local file only' . { #myWorld . #saveOnFile } }.
		{ 'see if server version is more recent...' . { #myProject . #loadFromServer } }.
		{ 'load project from file...' . { self . #loadProject } }.
"
		nil.
	}.

	self fillIn: menu from:
		{{'show project hierarchy'. {Project. #showProjectHierarchyInWindow}. 'Opens a window that shows names and relationships of all the projects in your system.'}.
		nil}.

	self mvcProjectsAllowed ifTrue: [
		self fillIn: menu from: {
			{ 'create new mvc project'. { self . #openMVCProject } }.
		}
	].
	self fillIn: menu from: { 
		{ 'create new morphic project' . { self . #openMorphicProject } }.
		nil.
		{ 'go to previous project' . { Project . #returnToPreviousProject } }.
		{ 'go to next project' . { Project . #advanceToNextProject } }.
		{ 'jump to project...' . { #myWorld . #jumpToProject } }.
	}.
	Preferences simpleMenus ifFalse: [
		self fillIn: menu from: { 
			nil.
			{ 'save for future revert' . { #myProject . #saveForRevert } }.
			{ 'revert to saved copy' . { #myProject . #revert } }.
		}.
	].

	^ menu! !

!TheWorldMenu methodsFor: 'as yet unclassified' stamp: 'cr 3/17/2005 02:54'!
openIRC self inform:'IRC is not present' ! !


!TheWorldMenu class methodsFor: 'open-menu registry' stamp: 'cr 3/16/2005 19:35'!
loadSqueakMap
	"Load the externally-maintained SqueakMap package if it is not already loaded.  Based on code by Gran Hultgren"

	self removed.
! !


!UndefinedObject methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 23:12'!
references: anObject
	^false.
! !

!UndefinedObject methodsFor: '*Shrinking' stamp: 'cr 3/22/2005 23:12'!
referencesOneOf: collection
	^false.
! !


!Utilities class methodsFor: 'fetching updates' stamp: 'cr 3/20/2005 02:07'!
updateFromServer
	"Update the image by loading all pending updates from the server.  Also save local copies of the update files if the #updateSavesFile preference is set to true"
	self removed.! !

!Utilities class methodsFor: 'miscellaneous' stamp: 'cr 3/20/2005 02:00'!
lookUpDefinition
	self removed.! !


!Vocabulary class methodsFor: 'class initialization' stamp: 'cr 3/23/2005 04:34'!
initializeStandardVocabularies
	"Initialize a few standard vocabularies and place them in the AllStandardVocabularies list."

	AllStandardVocabularies _ nil.
	self allStandardVocabularies.

"	self addEToyVocabulary."
"	self addEToyVectorVocabulary."

	self addStandardVocabulary: self newPublicVocabulary.
	self addStandardVocabulary: FullVocabulary new.

	self addStandardVocabulary: self newQuadVocabulary.

	self addStandardVocabulary: ColorType new.
	self addStandardVocabulary: BooleanType new.
	self addStandardVocabulary: GraphicType new.
	self addStandardVocabulary: PlayerType new.
"	self addStandardVocabulary: SoundType new."
	self addStandardVocabulary: StringType new.
	self addStandardVocabulary: MenuType new.
	self addStandardVocabulary: UnknownType new.
	self addStandardVocabulary: ScriptNameType new.

	self addStandardVocabulary: (SymbolListType new symbols: #(simple raised inset complexFramed complexRaised complexInset complexAltFramed complexAltRaised complexAltInset); vocabularyName: #BorderStyle; yourself).
	self addStandardVocabulary: (SymbolListType new symbols: #(leftToRight rightToLeft topToBottom bottomToTop); vocabularyName: #ListDirection; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(topLeft bottomRight center justified); vocabularyName: #ListCentering; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(buttonDown whilePressed buttonUp); vocabularyName: #ButtonPhase; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(rigid spaceFill shrinkWrap); vocabularyName: #Resizing; yourself).

	self addStandardVocabulary: self newSystemVocabulary.  "A custom vocabulary for Smalltalk -- still under development)"

	self numberVocabulary.  		"creates and adds it"
	self wonderlandVocabulary.  	"creates and adds it"
	self vocabularyForClass: Time.   "creates and adds it"

	"Vocabulary initialize"! !


!WorldState methodsFor: 'update cycle' stamp: 'cr 3/19/2005 19:21'!
doOneCycleInBackground
	"Do one cycle of the interactive loop. This method is called repeatedly when this world is not the active window but is running in the background."

self halt.		"not ready for prime time"


	"process user input events, but only for remote hands"  "remote hands removed."
"
	self handsDo: [:h |
		(h isKindOf: RemoteHandMorph) ifTrue: [
			ActiveHand _ h.
			h processEvents.
			ActiveHand _ nil]].
"

	self runStepMethods.
	self displayWorldSafely.
! !

DataStream initialize!
