#!/bin/bash

# Copyright (c) 2005 Chris Reuter. all rights reserved.
#
# This software may be freely redistributed under the terms of the GNU
# public license.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


# Run this script to play Quest For Pants without installing the
# game in a system directory.  Run this in the foreground.


# The directory into which the player's save file goes.
PLAYDIR=~/.qfpdir

# First, if this appears to be the user's first experience with the
# game, warn him/her that there's going to be a really big new file in
# his/her home directory.
if [ ! -d $PLAYDIR ]; then
	echo
	echo "It looks like you're about to play Quest For Pants for the first"
	echo "time.  QFP uses a lot of space and one of the first things it does"
	echo "is put a 26Mb save file in your home directory (in $PLAYDIR)."
	echo
	echo "Is this okay?"
	read -p 'Continue (y/n)? ' answer

	if [ "$answer" != "y" -a "$answer" != "Y" ]; then
		echo "Quitting."
		exit 0
	fi
fi


# We need to chdir into the installation directory because all the
# paths are relative to that from here on.

if cd `dirname $0`; then
	true
else
	echo "Error: Unable to change directory to `dirname $0`.  Quitting."
fi

bash unix/qfp.sh --play-now &

	
